//todo: suck indicator (possibly translucent lines that extend from mouth to distance of suckage) (have it along the indicator lines that are already there)
//todo: fix when food hits edge of fist/hand
//todo: have particles/explosions occur when level-up occurs for all food and bombs on board
//todo: splats and booms when food and bombs fall off table edge
//todo: Santa rotates faster with each level
//todo: food bounces back from center disc
//todo: bombs paralyze Santa temporarily, also destroy other nearby bombs
//todo: horizontal lines on suck indicator?
//todo: have Santa Bot begin changing directions in level > 5 (randomize the # of food releases till change)

import java.applet.*;
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.net.*;
import java.text.*;
import java.awt.Toolkit.*;
import java.awt.geom.*;
import java.util.*;
import javax.swing.ImageIcon;
import ibxm.*;
//import sun.audio.*;    //import the sun.audio package
import javax.sound.sampled.*;

public class fbx2k13 extends Applet implements Runnable, KeyListener, MouseListener, MouseMotionListener
{
        //applet dimensions
        final static int APP_W = 600;
        final static int APP_H = 600;
        final static float FAPP_W = (float)APP_W;
        final static float FAPP_H = (float)APP_H;

        final static int GAMESTATE_TITLE_INITIALIZE = -2;
        final static int GAMESTATE_TITLE = -1;
        final static int GAMESTATE_INITIALIZE = 0;
        final static int GAMESTATE_LEVEL_INITIALIZE = 1;
        final static int GAMESTATE_READY = 2;
        final static int GAMESTATE_LEVELUP = 3;
        final static int GAMESTATE_GAMEOVER_BEGIN = 4;
        final static int GAMESTATE_GAMEOVER = 5;

	final static int MAIN_DISC = 0;
	final static int CENTER_DISC = 1;
	final static int SANTA_DISC = CENTER_DISC;

	final static int MAX_PLAYER_MODES = 5;
	final static int MAX_PLAYER_ANIMS = 5;
	final static int MAX_DISCS = 16;
	final static int MAX_PLAYERS = 2;
        final static int MAX_PLAYER_NAME_LENGTH = 40;
	final static int MAX_GAME_MARBLES = 128;
	final static int MAX_GAME_PROJECTILES = 16;
	final static int FOOD_STREAK_THRESHOLD = 25;

	final static int MAX_SANTA_MODES = 3;
	final static int MAX_SANTA_ANIMS = 4;
	final static int SANTA_MODE_NORMAL = 0;
	final static int SANTA_MODE_DISABLED = 1;
	final static int SANTA_MODE_VICTORIOUS = 2;

	final static int MAX_EXPLODE_ANIMS = 3;
	final static int MAX_SPLAT_ANIMS = 3;
	final static int MAX_FIREPLACE_ANIMS = 3;

	final static long MARBLES_PER_LEVELUP = 24;     //# marbles needed for each level up
	final static int DEFAULT_MARBLE_SPAWN_TIMER = 160;
	final static int MIN_MARBLE_SPAWN_TIMER = DEFAULT_MARBLE_SPAWN_TIMER/4;   //minimum time between marble spawns
	final static float STARTING_MARBLE_SPEED = 0.75f;
	final static float DEFAULT_MARBLE_RADIUS = 15.0f;
	final static float DEFAULT_FB_RADIUS = 16.0f;
	final static float DEFAULT_SUCK_RADIUS = (float)Math.PI/24; //(float)Math.PI/32;
	final static float DEFAULT_SUCK_DRAW_RADIUS = (float)Math.PI/32;
	final static float DEFAULT_SUCK_LENGTH = 100.0f;
	final static float MAX_SUCK_LENGTH = DEFAULT_SUCK_LENGTH*1.5f;
	final static int DEFAULT_SUCK_SPACING = 10;
	final static int MAX_BOMB_ANIMS = marble.NUM_BOMB_ANIMS;

	final static int DEFAULT_SANTA_RADIUS = 24;
	final static float DEFAULT_SANTA_SPIN_SPEED = (float)Math.PI/128;
	final static float MAX_SANTA_SPIN_SPEED = (float)Math.PI/8;
	final static int DEFAULT_SANTA_DISABLED_TIME = 200;
	final static int DEFAULT_SANTA_DIRECTION_SWITCH_LIMIT = 10;

	final static int MAX_SNOWFLAKES = 128;

	final static String versionString = "Food Boy's Christmas Feast v02.17.2018a";

	//
	//various variables..
	//
    boolean isOnline = false;    //are we playing in a browser?
	boolean isApplication = true; //are we running as an application or an applet
	boolean useFullscreen = false; //are we using full-screen mode?
	boolean showImages = true;  //toggle between imaged and shaped graphics
	boolean debugOn = false;    //debugging toggle
	boolean hudOn = true;       //HUD toggle
	boolean paused = false;     //debugging
	boolean soundOn = true;     //sound toggle
	boolean musicOn = true;     //music toggle

	int angDiff = 0;
        //int gameState = GAMESTATE_INITIALIZE;
	int gameState = GAMESTATE_TITLE_INITIALIZE;

        //heads up display dimensions
        int hudW = APP_W;
        int hudH = 0;

        //playing area dimensions
        int playW = APP_W;
        int playH = APP_H-hudH;

	//sky dimensions
	int skyW = 0;
	int skyH = 0;

        //hiscore entry stuff
        String playerNameString = "Player 1";     //player name string for hiscore entry
        int curScoringMode = 0;
        boolean gotHiScore = false;
        boolean hiScoreEntryDone = false;

        Color borderClearColor = new Color(0, 96, 128);  //border background color
        Color clearColor = new Color(48, 63, 121);       //background color
        Color bgFloorColor = new Color(48, 63, 121);     //background floor color
        Color bgWallColor = new Color(68, 85, 124);      //background wall color
        Color bgSkyColor = new Color(14, 24, 43);        //background sky color
        Color gridColor = new Color(0.75f, 0.75f, 0.75f);
        Color hudColor = new Color(0.6f,0.6f,0.6f,1.0f);   //the color used for the heads up display
	Color playerHighlightColor = new Color(255, 255, 255, 128);
	Color[] marbleColor = new Color[marble.MAX_COLORS];  //the list of marble colors..

	//use these for the loading sequence
	int numGameResources = 56;
	int numGameResourcesLoaded = 0;

	int fistRadius = 24;             //radius of fist
	int numPlayers = 1;              //# players playing..
	int curLevel = 0;                //current level..
	long nextLevelUp = MARBLES_PER_LEVELUP;   //next level up marble total..
	int maxLevels = 30;              //max levels (might not use this..)
	int numDiscs = 0;                //# discs in the playfield..
	int numMarbles = 0;              //# marbles..
	int numStartingMarbles = 8;      //# marbles to start the game off with
	int numProjectiles = 0;          //# projectiles/shots..
	int curStartingDiscSize = 230;   //current size of the starting (outer) disc
	float curMarbleRadius = marble.DEFAULT_RADIUS;   //current marble radius for newly-released marbles..
	float curMarbleSpeed = STARTING_MARBLE_SPEED;   //speed of released marbles..
	float santaRadius = DEFAULT_SANTA_RADIUS;
	float santaSpinSpeed = DEFAULT_SANTA_SPIN_SPEED;  //Santa's spin speed, of course...
	int santaMode = SANTA_MODE_NORMAL;
	int numSantaAnims = 3;
	int santaAnimCounter = 0;
	int santaAnimSpeed = 4;
	int santaDisabledTimer = 0;
	int santaSwitchCounter = 0;      //current Santa Bot switch counter
	int santaSwitchLimit = DEFAULT_SANTA_DIRECTION_SWITCH_LIMIT;   //# food releases till we switch
	boolean santaFalling = true;     //for when Santa is falling onto the table
	float santaYOffset = -playH/2-50; //offset for when Santa is falling onto the table
	float santaYVel = 4.0f;          //Santa's falling velocity
	float santaYAccel = 0.5f;        //Santa's falling acceleration
	boolean santaAnimRev = false;    //Santa animation stuff...
	boolean mouseControls = true;    //toggle mouse controls..
	boolean mouseDepressed = false;  //tells if mouse is pressed (for firing)
	boolean keyDepressed = false;    //tells if key is pressed (for firing/sucking)
	static int[] arcActive = new int[360];   //the arc buffer
	float suckLength = DEFAULT_SUCK_LENGTH;
	int suckCounter = 0;             //for animating suck lines
	boolean stillSucking = false;    //still sucking...
	boolean levelUp = false;         //tells when we need to level up
	boolean startGameOver = false;   //tells when we need to start Game Over
	int numSnowFlakes = 72;          //total # of snowflakes
	int fireAnimCounter = 0;
	int fireAnimSpeed = 4;
	boolean fireAnimRev = false;     //fire animation variables
	float logoYOffset = 0.0f;        //logo variables
	boolean logoReverse = false;
	long curHiScore = 0;             //current highest score
	int hiScoreStatus = 0;           //tells if we've gotten the high score
	boolean fancyFont = false;       //tells if we loaded the fancy font
	boolean useInvokeLater = isOnline;   //use this for fixing the key_released bug

	int marbleSpawnTimer = DEFAULT_MARBLE_SPAWN_TIMER;   //countdown timer to marble/item release..

	//
	//screen buffer stuff..
	//
        Image img_scBuff = null;         //screen buffer
        Graphics g_scBuff = null;        //screen buffer graphics context

	//
	//font stuff
	//
        Font gameFont = null;
	Font gameFontBig = null;
        Font hudFont = null;
        int fontW = 8, fontH = 12;
        int fontBigW = (fontW-1)*2, fontBigH = fontH*2;

	//
	//various vertices
	//
        vertex playFieldPos = new vertex(playW/2, playH/2+20);
        //vertex hudPos = new vertex(0.0f, FAPP_H-(float)hudH);   //placement of the heads up display (score, etc.)
        vertex hudPos = new vertex(0.0f, FAPP_H-(float)fontH*3-1);   //placement of the heads up display (score, etc.)
        vertex hudEnergyPos = new vertex(79, 7);
        vertex hudScorePos = new vertex(55, 14);
        vertex hudHiScorePos = new vertex(55, 32);
        vertex hudLevelPos = new vertex(375, 18);
        vertex hudClockPos = new vertex(134, 25);
	vertex bgTreePos = new vertex(0, 10);
	vertex bgFireplacePos = new vertex(412, -3);
	vertex bgWindowPos = new vertex(220, 0);
	vertex bgSkyPos = new vertex();
	vertex bgFirePos = new vertex(470, 30);
	vertex logoPos = new vertex(40, playH/2-200);
//	vertex gameOverPos = new vertex(playW/2-110, playH/2-200);
	vertex gameOverPos = new vertex(playW, playH/2-250);
	vertex gameOverVel = new vertex(-30, 0);

	//
	//images..
        //
	Image hudImage = null;           //heads up display bitmap
	BufferedImage[] marbleImage = new BufferedImage[marble.MAX_COLORS];
	BufferedImage[] bombImage = new BufferedImage[MAX_BOMB_ANIMS];
	BufferedImage[][] fbImage = new BufferedImage[MAX_PLAYER_MODES][MAX_PLAYER_ANIMS];
	BufferedImage[] fbHandImage = new BufferedImage[2];
	BufferedImage[][] santaImage = new BufferedImage[MAX_SANTA_MODES][MAX_SANTA_ANIMS];
	BufferedImage[] explodeImage = new BufferedImage[MAX_EXPLODE_ANIMS];
	BufferedImage[] splatImage = new BufferedImage[MAX_SPLAT_ANIMS];
	BufferedImage gameOverImage = null;
	BufferedImage logoImage = null;
	BufferedImage treeImage = null;
	BufferedImage fireplaceImage = null;
	BufferedImage windowImage = null;
	BufferedImage[] fireImage = new BufferedImage[MAX_FIREPLACE_ANIMS];
	BufferedImage rugImage = null;

	//
	//sound files
	//online sounds
    AudioClip soundChomp = null;
	AudioClip soundExplosion = null;
	AudioClip soundLevelUp = null;
	AudioClip soundSmash = null;
	AudioClip soundBounce = null;
	AudioClip soundShot = null;
	AudioClip soundLevelIn = null;
	AudioClip soundLaugh = null;
	AudioClip soundHi = null;
	//offline sounds
	Clip soundChompC = null;
	Clip soundExplosionC = null;
	Clip soundLevelUpC = null;
	Clip soundSmashC = null;
	Clip soundBounceC = null;
	Clip soundShotC = null;
	Clip soundLevelInC = null;
	Clip soundLaughC = null;
	Clip soundHiC = null;

	musicPlayer music_player;
	Module gameSong;
	Module gameOverSong;
//	AudioClip gameSong = null;
//	AudioClip gameOverSong = null;

	IBXM musicPlayer = null;
	//
	//game structures..
	//
        //AverageTimer gameAverageTimer = null;   //average time for display sync
        Thread mainThread = null;        	  //main thread
        clock gameClock = new clock();            //game clock
        hiScoreBank gameHiScoreBank = new hiScoreBank();  //game high scores listings
	player[] gamePlayer = new player[MAX_PLAYERS];
	disc[] gameDisc = new disc[MAX_DISCS];
	marble[] gameMarble = new marble[MAX_GAME_MARBLES];
	projectile[] gameProjectile = new projectile[MAX_GAME_PROJECTILES];
	particleBank gameParticleBank = new particleBank();
	snowFlake[] snow = new snowFlake[MAX_SNOWFLAKES];

        //applet init sequence
        public void init()
        {
                setBackground(clearColor);  //set bg color
                resize(APP_W, APP_H);       //set applet dimensions

                //create screen buffer
                try{
                        img_scBuff = createImage(APP_W, APP_H);
                        g_scBuff = img_scBuff.getGraphics();
                        }
                catch(Exception e){
                        System.out.println("screen buffer not created..");
                        img_scBuff = null;
                        g_scBuff = null;
                        return;
                        }

                g_scBuff.setColor(clearColor);
                g_scBuff.fillRect(0, 0, APP_W, APP_H);

                //add listeners
                addMouseListener(this);
                addMouseMotionListener(this);
                //addKeyListener(this);
                addKeyListener(KeyListenerWrapper.init(this, useInvokeLater));

                //load saved hiscores
        }

        //start the main thread
        public void start()
        {
                if(mainThread == null)
		{
                        mainThread = new Thread(this);
                        mainThread.start();   //invokes run()
                }
        }

        //kill the main thread
        public void stop()
        {
                mainThread = null;
        }

        //draw stuff to the screen
        public void paint(Graphics g)
        {
                if(img_scBuff != null)
		{
                        g.drawImage(img_scBuff, 0, 0, this);  //draw the screen buffer to the graphics context
		}
        }

        //update the supplied graphics context
        public void update(Graphics g)
        {
                paint(g);
        }

        public void run()
        {
                System.out.println("applet starting...");

                if(g_scBuff == null) return; //make sure double buffer created properly

                Graphics g = getGraphics();

                //register font
                g.setFont(gameFont);
                g_scBuff.setFont(gameFont);

                //make sure initialization occurs without incident
                if(!initApp(g)) return;

                System.out.println("entering main loop...");

                //keep looping until the thread is killed
                while(mainThread != null)
		{
                        updateApp();  //handle logic
                        paintApp(g);  //handle display

                        try{   //take a little nap
                                Thread.sleep(10);
                                }catch(InterruptedException e) { stop(); }
		}

                System.out.println("applet cleanly exited.");
        }

        //draw the loading bar..
        void drawLoadingBar(Graphics g, int x, int y, int w, int h, int count, int endCount, Color fillColor, Color outlineColor)
        {
                float ratio = (float)count/endCount;
                g.setColor(fillColor);
                g.fillRect(x, y, (int)(w*ratio), h);
                g.setColor(outlineColor);
                g.drawRect(x, y, w, h);
        }

        //load all the images up before we start going
        void loadGameImages(Graphics g)
        {
		//load FB images
		fbImage[0][0] = loadBufferedImage("fb0000.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		fbImage[1][0] = loadBufferedImage("fb0001.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		fbImage[1][1] = loadBufferedImage("fb0002.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		fbImage[1][2] = loadBufferedImage("fb0003.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		fbImage[2][0] = loadBufferedImage("fb0100.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		fbImage[2][1] = loadBufferedImage("fb0101.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		fbImage[2][2] = loadBufferedImage("fb0102.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		fbImage[2][3] = loadBufferedImage("fb0103.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		fbImage[2][4] = loadBufferedImage("fb0104.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		fbImage[3][0] = loadBufferedImage("fb0300.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		fbImage[4][0] = loadBufferedImage("fb0400.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);

		//load FB hand images
		fbHandImage[0] = loadBufferedImage("fbhand00.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		fbHandImage[1] = loadBufferedImage("fbhand01.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);

		//load food images
		marbleImage[0] = loadBufferedImage("food0000.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		marbleImage[1] = loadBufferedImage("food0001.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		marbleImage[2] = loadBufferedImage("food0002.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		marbleImage[3] = loadBufferedImage("food0003.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		marbleImage[4] = loadBufferedImage("food0006.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		marbleImage[5] = loadBufferedImage("food0007.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		marbleImage[8] = loadBufferedImage("marb0080.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		marbleImage[9] = loadBufferedImage("marb0090.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);

		//load bomb images
		bombImage[0] = loadBufferedImage("bomb0000.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		bombImage[1] = loadBufferedImage("bomb0001.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		bombImage[2] = loadBufferedImage("bomb0002.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);

		//load Santa images
		santaImage[SANTA_MODE_NORMAL][0] = loadBufferedImage("santa0000.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		santaImage[SANTA_MODE_NORMAL][1] = loadBufferedImage("santa0001.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		santaImage[SANTA_MODE_NORMAL][2] = loadBufferedImage("santa0002.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		santaImage[SANTA_MODE_DISABLED][0] = loadBufferedImage("santa0100.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		santaImage[SANTA_MODE_DISABLED][1] = loadBufferedImage("santa0101.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		santaImage[SANTA_MODE_DISABLED][2] = loadBufferedImage("santa0102.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		santaImage[SANTA_MODE_VICTORIOUS][0] = loadBufferedImage("santa0200.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		santaImage[SANTA_MODE_VICTORIOUS][1] = loadBufferedImage("santa0201.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		santaImage[SANTA_MODE_VICTORIOUS][2] = loadBufferedImage("santa0202.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);

		//load explosion and splat images
		explodeImage[0] = loadBufferedImage("expl0000.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		explodeImage[1] = loadBufferedImage("expl0001.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		explodeImage[2] = loadBufferedImage("expl0002.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		splatImage[0] = loadBufferedImage("expl0100.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		splatImage[1] = loadBufferedImage("expl0101.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		splatImage[2] = loadBufferedImage("expl0102.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);

		//load logos, etc.
		gameOverImage = loadBufferedImage("gameover.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		logoImage = loadBufferedImage("fbxlogo.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);

		//load background images
		treeImage = loadBufferedImage("tree00.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		fireplaceImage = loadBufferedImage("fireplace.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		windowImage = loadBufferedImage("window.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		fireImage[0] = loadBufferedImage("firelogs00.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		fireImage[1] = loadBufferedImage("firelogs01.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		fireImage[2] = loadBufferedImage("firelogs02.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		rugImage = loadBufferedImage("rug.png");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
        }

		//load a clip from a file
		Clip loadAudioClipFile(String filename)
		{
				File file = null;
				URL url = null;
				AudioInputStream ais = null;
				Clip clip = null;
				AudioFileFormat aff = null;
				AudioFormat af = null;

				URL soundURL = null;
				try
				{
					soundURL = getClass().getClassLoader().getResource(filename);
					if(soundURL == null){ System.out.println("SoundURL is null. Aborting."); return null; }
					Line.Info linfo = new Line.Info(Clip.class);
					if(linfo == null){ System.out.println("Linfo is null. Aborting."); return null; }
				    Line line = AudioSystem.getLine(linfo);
					if(line == null){ System.out.println("Line is null. Aborting."); return null; }
				    clip = (Clip)line;
					if(clip == null){ System.out.println("Clip is null. Aborting."); return null; }
				    ais = AudioSystem.getAudioInputStream(soundURL);
					if(ais == null){ System.out.println("AIS is null. Aborting."); return null; }
				    clip.open(ais);
				}

				catch(Exception e)
				{
	           		e.printStackTrace();
	       		}

				if(clip != null)
				{
					System.out.println("Clip has frame length of " + clip.getFrameLength());
					//clip.setLoopPoints(0, clip.getFrameLength());
				}

				return clip;
		}

	//load game audio assets
	void loadGameSounds(Graphics g)
	{
			InputStream in = null;

			//do this if we're in application mode
			if(!isOnline)
			{
				soundChompC = loadAudioClipFile("sfx_chom.wav");
				drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
                soundExplosionC = loadAudioClipFile("sfx_expl.wav");
				drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
                soundLevelUpC = loadAudioClipFile("sfx_lvup.wav");
				drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
                soundSmashC = loadAudioClipFile("sfx_smas.wav");
				drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
                soundBounceC = loadAudioClipFile("sfx_boun.wav");
				drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
                soundShotC = loadAudioClipFile("sfx_shot.wav");
				drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
				soundLaughC = loadAudioClipFile("sfx_santa.wav");
				drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
                soundHiC = loadAudioClipFile("sfx_w000.wav");
				drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
				gameSong = loadMusic("bgm.xm");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
	        	gameOverSong = loadMusic("title.xm");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
				}
			else
			{
				soundChomp = getAudioClip(getDocumentBase(), "sfx_chom.wav");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
                soundExplosion = getAudioClip(getDocumentBase(), "sfx_expl.wav");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
                soundLevelUp = getAudioClip(getDocumentBase(), "sfx_lvup.wav");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
		//soundLevelIn = getAudioClip(getDocumentBase(), "sfx_lvin.wav");
                soundSmash = getAudioClip(getDocumentBase(), "sfx_smas.wav");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
                soundBounce = getAudioClip(getDocumentBase(), "sfx_boun.wav");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
                soundShot = getAudioClip(getDocumentBase(), "sfx_shot.wav");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
				soundLaugh = getAudioClip(getDocumentBase(), "sfx_santa.wav");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
				soundHi = getAudioClip(getDocumentBase(), "sfx_w000.wav");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
        		gameSong = loadMusic("bgm.xm");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
	        	gameOverSong = loadMusic("title.xm");
                drawLoadingBar(g, fontW*2, fontH*2+2, playW/2, fontH+2, ++numGameResourcesLoaded, numGameResources, Color.WHITE, Color.GRAY);
			}
	}

	//load all game resources
	void loadGameResources(Graphics g)
	{
		loadGameImages(g);
		loadGameSounds(g);
	}

        //set the hiscore stuff up
        void initializeHiScoreStuff()
        {
			loadHiScores();
/*
                if(isOnline)
		{
                        loadHiScores();
		}
		else
		{
			gameHiScoreBank.initializeDummyScores(5000);
		}
*/
			curHiScore = gameHiScoreBank.score[0].score;
        }

        //applet initialization sequence
        boolean initApp(Graphics g)
        {
                //start the average timer..
                //gameAverageTimer = new AverageTimer( System.currentTimeMillis() );

                //register the font
                //gameFont = new Font("monospaced", Font.BOLD, fontH);
                //hudFont = new Font("sansserif", Font.BOLD, 10);
		//gameFont = new Font("DoctorSoosBold.ttf", Font.BOLD, fontH);
		//gameFontBig = new Font("DoctorSoosBold.ttf", Font.BOLD, fontBigH);
		//hudFont = new Font("DoctorSoosBold.ttf", Font.BOLD, 10);
/*
		try
		{
			Font tempFont;
			tempFont = Font.createFont(Font.TRUETYPE_FONT, new File("DoctorSoosBold.ttf"));
			gameFont = tempFont.deriveFont(Font.PLAIN, fontH*2);
		}
                catch(Exception e)
		{
                        System.out.println("font not loaded...");
                }
		gameFontBig = gameFont.deriveFont(Font.PLAIN, fontH*3);
		hudFont = gameFont.deriveFont(Font.PLAIN, fontH*2);
*/
//xxx
		try
		{
			if(isOnline)
			{
				URL fontUrl = new URL(getCodeBase(), "DoctorSoosBold.ttf");
				Font tempFont = Font.createFont(Font.TRUETYPE_FONT, fontUrl.openStream());
				if(tempFont == null) System.out.println("error creating tempFont...");
				gameFont = tempFont.deriveFont(Font.PLAIN, fontH*2);
				if(gameFont == null) System.out.println("error creating gameFont...");
			}
			else
			{
				URL fontUrl = null;
				//URL fontUrl = new File("DoctorSoosBold.ttf").toURI().toURL();

				//try{ fontUrl = getClass().getClassLoader().getResource("/DoctorSoosBold.ttf"); } catch(Exception E){ System.out.println("File DoctorSoosBold.ttf not found."); }
				//Font tempFont = Font.createFont(Font.TRUETYPE_FONT, fontUrl.openStream());
				InputStream is = this.getClass().getResourceAsStream("DoctorSoosBold.ttf");
				Font tempFont = Font.createFont(Font.TRUETYPE_FONT, is);
				if(tempFont == null) System.out.println("error creating tempFont...");
				gameFont = tempFont.deriveFont(Font.PLAIN, fontH*2);
				if(gameFont == null) System.out.println("error creating gameFont...");
			}
		}
                catch(Exception e)
		{
                        System.out.println("font not loaded...");
                }
		if(gameFont != null)
		{
			System.out.println("Deriving fancy fonts...");
			gameFontBig = gameFont.deriveFont(Font.PLAIN, fontH*3);
			hudFont = gameFont.deriveFont(Font.PLAIN, fontH*2);
			fancyFont = true;
		}
		else
		{
			fontW = 10;
			fontH = 16;
			fontBigW = fontW*2;
			fontBigH = fontH*2;

			System.out.println("Falling back to standard fonts...");
	                gameFont = new Font("monospaced", Font.BOLD, fontH);
	                gameFontBig = new Font("monospaced", Font.BOLD, fontBigH);
	                hudFont = new Font("monospaced", Font.BOLD, fontH);
			fancyFont = false;
		}

		g.setColor(Color.GRAY);
		g.drawString(versionString, 0, fontH);
                g.drawString("Loading game resources..", 0, fontH*2);
                //load game image files
                loadGameResources(g);

		g.setColor(Color.GRAY);
                g.drawString("Loading hiscores from server..", 0, fontH*5);
                //set the hiscore-related stuff up
                initializeHiScoreStuff();

                //ah! success!
                return true;
        }

        //keyboard listener stuff
        public void keyPressed(KeyEvent e)
	{
		int k = e.getKeyCode();
                if(gameState == GAMESTATE_READY)
		{
			//rotate left..
			if(k == KeyEvent.VK_LEFT)
			{
				gamePlayer[0].rotateLeftAbsolute();
				updatePlayerCoords(gamePlayer[0]);
			}
			else if(k == KeyEvent.VK_RIGHT)
			{
				gamePlayer[0].rotateRightAbsolute();
				updatePlayerCoords(gamePlayer[0]);
			}
			else if(k == KeyEvent.VK_P)
			{
				paused = !paused;
				System.out.println(paused ? "paused..." : "unpaused...");
			}
			else if(k == KeyEvent.VK_D)
			{
				debugOn = !debugOn;
				System.out.println(debugOn ? "debug on..." : "debug off...");
			}
			else if(k == KeyEvent.VK_H)
			{
				hudOn = !hudOn;
				System.out.println(hudOn ? "HUD on..." : "HUD off...");
			}
			else if(k == KeyEvent.VK_S)
			{
				soundOn = !soundOn;
				String msg1 = new String(soundOn ? "Sound effects enabled" : "Sound effects disabled");
				String msg2 = new String(!soundOn ? "Sound effects enabled" : "Sound effects disabled");
				System.out.println(msg1);
				gameParticleBank.disableParticleWithString(msg2);
				gameParticleBank.addParticle(new vertex(playW/2-fontW*msg1.length()/2, 20), new vertex(), msg1, gameFont, new Color(225, 243, 241), 0, 0, particle.SHAPE_TEXT, 60);
			}
			else if(k == KeyEvent.VK_M)
			{
				musicOn = !musicOn;
				String msg1 = new String(musicOn ? "Music enabled" : "Music disabled");
				String msg2 = new String(!musicOn ? "Music enabled" : "Music disabled");
				System.out.println(msg1);
				gameParticleBank.disableParticleWithString(msg2);
				gameParticleBank.addParticle(new vertex(playW/2-fontW*msg1.length()/2, 40), new vertex(), msg1, gameFont, new Color(225, 243, 241), 0, 0, particle.SHAPE_TEXT, 60);
				//stop the current song
				if(!musicOn)
				{
					stopMusic();
				}
				//start the current song
				else
				{
					if(gameState == GAMESTATE_READY)
					{
						playMusic(gameSong);
					}
					else if(gameState == GAMESTATE_GAMEOVER)
					{
						playMusic(gameOverSong);
					}
				}
			}
			//alternate keyboard method for sucking
			else if(k == KeyEvent.VK_Z)
			{
				//if(stillSucking) return;
				if(keyDepressed || stillSucking) return;

				if(gameState == GAMESTATE_READY)
				{
					//start sucking if we can
					if(!gamePlayer[0].isOuched())
					{
						System.out.println("starting suck with key...");
						gamePlayer[0].startSuck();
						stillSucking = true;
					}
				}

				keyDepressed = true;
			}
                }
                else if(gameState == GAMESTATE_READY)
		{
		}
        }
        public void keyReleased(KeyEvent e)
	{
		int k = e.getKeyCode();
                if(gameState == GAMESTATE_READY)
		{
			//alternate keyboard method for sucking
			if(k == KeyEvent.VK_Z)
			{
				if(gamePlayer[0].isSucking())
				{
					//not sucking anymore, I'm afraid
					stillSucking = false;

					//reset the suck length
					suckLength = DEFAULT_SUCK_LENGTH;

					//stop the suck action
					gamePlayer[0].stopSuck();

					System.out.println("stopping suck with key...");
				}
				keyDepressed = false;
			}
		}
        }
        public void keyTyped(KeyEvent e)
	{
                switch(gameState)
		{
                        case GAMESTATE_GAMEOVER:
                                if(gotHiScore && !hiScoreEntryDone)
				{
                                        //backspace.. erase last letter
                                        if(e.getKeyChar() == (char)8)
					{
                                                if(playerNameString.length() > 0)
						{
                                                        int len = playerNameString.length();
                                                        String str = playerNameString.substring(0, len-1);
                                                        playerNameString = str;
                                                }
					}
                                        //else if(e.getKeyCode() == KeyEvent.VK_ENTER)
                                        else if(e.getKeyChar() == '\n')
					{
                                                finishHiScoreEntry();
                                        }
                                        else
					{
                                                if(playerNameString.length() < MAX_PLAYER_NAME_LENGTH)
						{
                                                        playerNameString += e.getKeyChar();
                                                }
                                        }
                                }
                                break;
                        default:
                                break;
		}
	}

        //mouse listener stuff
        public void mousePressed(MouseEvent e)
	{
		if(mouseDepressed) return;
		System.out.println("mouse pressed...");

		switch(gameState)
		{
			case GAMESTATE_READY:
				if(e.getButton() == MouseEvent.BUTTON1)
				{
					//start sucking if we can
					if(!gamePlayer[0].isOuched())
					{
						gamePlayer[0].startSuck();
						stillSucking = true;
					}
				}
				else
				{
					//gamePlayer[0].stopSuck();
				}

				break;
			default:
				break;
		}

		mouseDepressed = true;
	}
        public void mouseClicked(MouseEvent e)
        {
		System.out.println("mouse clicked...");
                switch(gameState)
		{
                        case GAMESTATE_TITLE:  //start the game on click
                                gameState = GAMESTATE_INITIALIZE;

                                break;
                        case GAMESTATE_GAMEOVER:  //restart the game on click
                                //don't restart if the player isn't done entering his/her name..
                                if(gotHiScore && !hiScoreEntryDone) return;

                                gameState = GAMESTATE_INITIALIZE;

				//reset Santa's spin speed and angle
				gameDisc[SANTA_DISC].angleVel = santaSpinSpeed;
				gameDisc[SANTA_DISC].angle = (float)Math.PI;

				//stop the laughter if necessary
				stopLaughSound();

				//stop the game-over music if it's playing
				if(musicOn) stopMusic();

                                break;
                        default:
                                break;
		}
        }

        public void mouseEntered(MouseEvent e){ }
        public void mouseExited(MouseEvent e){ }
        public void mouseReleased(MouseEvent e)
	{
		System.out.println("mouse released...");
		mouseDepressed = false;

		switch(gameState)
		{
			case GAMESTATE_TITLE:
				break;
			case GAMESTATE_READY:
				if(gamePlayer[0].isSucking())
				{
					//not sucking anymore, I'm afraid
					stillSucking = false;

					//reset the suck length
					suckLength = DEFAULT_SUCK_LENGTH;

					//stop the suck action
					gamePlayer[0].stopSuck();
				}
				break;
			default:
				break;
		}
	}
        public void mouseDragged(MouseEvent e){ }
        public void mouseMoved(MouseEvent e)
	{
		switch(gameState)
		{
			case GAMESTATE_READY:
				if(!mouseControls) return;
				//find the angle between the mouse pointer and the disc's center..
				float x = gameDisc[gamePlayer[0].curDisc].pos.x-(float)e.getX();
				float y = gameDisc[gamePlayer[0].curDisc].pos.y-(float)e.getY();
				float ang = (float)Math.atan2(y, x)-(float)Math.PI;
				gamePlayer[0].destAngle = (float)vertex.angleMod(ang);
				updatePlayerCoords(gamePlayer[0]);

				break;
			default:
				break;
		}
	}

        //draw the clock all digital-like
        void clockDisplay(Graphics g, clock co, int x, int y, Color color, int fontSize)
        {
                Font clockFont = new Font("monospaced", Font.BOLD, fontSize);
                g.setColor(color);
                g.drawString("" + intNumberString(co.mins, 2) + ":" + intNumberString(co.secs, 2), x, y);
        }

        //draw the debris/particles..
        void particleDisplay(Graphics g, particleBank pb)
        {
                for(int i = 0; i < pb.numParticles; i++)
		{
                        if(pb.bParticle[i] == null || pb.bParticle[i].isInactive()) continue;  //skip over inactive particles
			if(pb.bParticle[i].isCircle())
			{
				g.setColor(pb.bParticle[i].color);
				g.drawOval((int)(pb.bParticle[i].pos.x-pb.bParticle[i].hRad)-pb.bParticle[i].c1/(pb.bParticle[i].c3*2), (int)(int)(pb.bParticle[i].pos.y-pb.bParticle[i].vRad)-pb.bParticle[i].c1/(pb.bParticle[i].c3*2), (int)pb.bParticle[i].hRad*2+pb.bParticle[i].c1/pb.bParticle[i].c3, (int)pb.bParticle[i].vRad*2+pb.bParticle[i].c1/pb.bParticle[i].c3);
			}
			else if(pb.bParticle[i].isCircleFilled())
			{
				g.setColor(pb.bParticle[i].color);
				g.fillOval((int)(pb.bParticle[i].pos.x-pb.bParticle[i].hRad), (int)(pb.bParticle[i].pos.y-pb.bParticle[i].vRad), (int)pb.bParticle[i].hRad*2, (int)pb.bParticle[i].vRad*2);
			}
			else if(pb.bParticle[i].isText())
			{
				if(pb.bParticle[i].isTextBig()) g.setFont(gameFontBig);
				else g.setFont(gameFont);
				g.setColor(pb.bParticle[i].color);
				drawStringShadowed(g, pb.bParticle[i].txt, pb.bParticle[i].color, (int)pb.bParticle[i].pos.x, (int)pb.bParticle[i].pos.y, 2, 2);
				/*
				g.setColor(Color.BLACK);
				g.drawString(pb.bParticle[i].txt, (int)pb.bParticle[i].pos.x+1, (int)pb.bParticle[i].pos.y+1);
				g.setColor(pb.bParticle[i].color);
				g.drawString(pb.bParticle[i].txt, (int)pb.bParticle[i].pos.x, (int)pb.bParticle[i].pos.y);
				*/
				g.setFont(gameFont);
			}
		}
        }

	//draw the pretty snow..
	void snowDisplay(Graphics g, snowFlake sf[], int num)
	{
		for(int s = 0; s < num; s++)
		{
			if(sf[s] == null) continue;
			g.setColor(new Color(sf[s].shade, sf[s].shade, sf[s].shade));
			g.fillRect((int)sf[s].pos.x, (int)sf[s].pos.y, sf[s].radius*2, sf[s].radius*2);
		}
	}

	//draw the marble queue/ring
	void playerMarbleDisplay(Graphics g, player pl)
	{
		/*
		for(int i = 0; i < pl.numMarbles; i++){
			if(pl.pMarble[i] == null || pl.pMarble[i].isInactive()) continue;

			if(!showImages){
				//draw the marble body
				g.setColor(marbleColor[pl.pMarble[i].getColor()]);
				g.fillOval((int)(gameDisc[pl.curDisc].pos.x+gameDisc[pl.curDisc].radius*(float)Math.cos(pl.angle+pl.pMarble[i].angle)-pl.pMarble[i].radius), (int)(gameDisc[pl.curDisc].pos.y+gameDisc[pl.curDisc].radius*(float)Math.sin(pl.angle+pl.pMarble[i].angle)-pl.pMarble[i].radius), (int)pl.pMarble[i].radius*2, (int)pl.pMarble[i].radius*2);
				//draw a shiny on the upper corner..
				g.setColor(marbleColor[pl.pMarble[i].getColor()].brighter());
				g.fillRect((int)(gameDisc[pl.curDisc].pos.x+gameDisc[pl.curDisc].radius*(float)Math.cos(pl.angle+pl.pMarble[i].angle)-6.0f), (int)(gameDisc[pl.curDisc].pos.y+gameDisc[pl.curDisc].radius*(float)Math.sin(pl.angle+pl.pMarble[i].angle)-6.0f), 4, 4);
				}
			else{
				g.drawImage(marbleImage[pl.pMarble[i].getColor()], (int)(gameDisc[pl.curDisc].pos.x+gameDisc[pl.curDisc].radius*(float)Math.cos(pl.angle+pl.pMarble[i].angle)-pl.pMarble[i].radius), (int)(gameDisc[pl.curDisc].pos.y+gameDisc[pl.curDisc].radius*(float)Math.sin(pl.angle+pl.pMarble[i].angle)-pl.pMarble[i].radius), this);
				}

			}
		*/
	}

	//draw the Santa Bot
	void santaDisplay(Graphics2D g2d)
	{
		//find the center of Santa
		int x = (int)(gameDisc[MAIN_DISC].pos.x-santaRadius);
		int y = (int)(gameDisc[MAIN_DISC].pos.y-santaRadius);

		//do the transformation on the Santa image
                AffineTransform trans = new AffineTransform();
                BufferedImage bi = toBufferedImage(santaImage[santaMode][getCurSantaAnimFrame()]);
                Graphics2D g2b = bi.createGraphics();
		if(santaMode == SANTA_MODE_NORMAL) trans.scale(1.0f+gameDisc[SANTA_DISC].bulgeOffset/80, 1.0f+gameDisc[SANTA_DISC].bulgeOffset/80);
		else if(santaMode == SANTA_MODE_VICTORIOUS) trans.scale(1.0f+gameDisc[SANTA_DISC].bulgeOffset/30, 1.0f+gameDisc[SANTA_DISC].bulgeOffset/30);

                //trans.setToIdentity();
                trans.rotate(gameDisc[CENTER_DISC].angle+Math.PI, (int)santaRadius, (int)santaRadius);
                //trans.rotate(gameDisc[CENTER_DISC].angle+Math.PI/32, (int)santaRadius, (int)santaRadius);
                g2b.transform(trans);
                AffineTransformOp transOp = new AffineTransformOp(trans, 2);

		g2d.drawImage(santaImage[santaMode][getCurSantaAnimFrame()], transOp, (int)x, (int)(y+santaYOffset));

		if(!debugOn) return;

		g2d.setColor(Color.RED);
		g2d.drawString("av:" + gameDisc[SANTA_DISC].angleVel, (int)gameDisc[SANTA_DISC].pos.x+50, (int)gameDisc[SANTA_DISC].pos.y);
/*
		//standard Santa in-game drawing
		if(!santaFalling)
		{
			//do the transformation on the Santa image
	                AffineTransform trans = new AffineTransform();
	                BufferedImage bi = toBufferedImage(santaImage[santaMode][getCurSantaAnimFrame()]);
	                Graphics2D g2b = bi.createGraphics();
			if(santaMode == SANTA_MODE_NORMAL) trans.scale(1.0f+gameDisc[SANTA_DISC].bulgeOffset/80, 1.0f+gameDisc[SANTA_DISC].bulgeOffset/80);
			else if(santaMode == SANTA_MODE_VICTORIOUS) trans.scale(1.0f+gameDisc[SANTA_DISC].bulgeOffset/30, 1.0f+gameDisc[SANTA_DISC].bulgeOffset/30);

	                //trans.setToIdentity();
	                trans.rotate(gameDisc[CENTER_DISC].angle+Math.PI, (int)santaRadius, (int)santaRadius);
	                //trans.translate((int)fb.pos.x, (int)fb.pos.y);
	                g2b.transform(trans);
	                AffineTransformOp transOp = new AffineTransformOp(trans, 2);

			g2d.drawImage(santaImage[santaMode][getCurSantaAnimFrame()], transOp, (int)x, (int)y);
			//g.drawImage(fbImage[0][0], (int)(x-pl.radius), (int)(y-pl.radius), this);
			//g2d.drawImage(fbImage[0][0], transOp, (int)x, (int)y, this);
	                //g2.drawImage(fbImage[0][0], zBufferSprite[i].imgOp, (int)zBufferSprite[i].x-zBufferSprite[i].w2, (int)(zBufferSprite[i].y-zBufferSprite[i].z)-zBufferSprite[i].h2);
		}
		//drawing Santa when he's falling onto the table...
		else
		{
	                AffineTransformOp transOp = new AffineTransformOp(new AffineTransform(), 2);
			g2d.drawImage(santaImage[santaMode][getCurSantaAnimFrame()], transOp, (int)x, (int)(y+santaYOffset));
		}
*/
	}

	//draw Food Boy and his arc
	void playerFBDisplay(Graphics2D g2d, player pl)
	{
		//find the center of FB's head
		int x = (int)(gameDisc[pl.curDisc].pos.x+(gameDisc[pl.curDisc].radius-pl.riseOffset)*(float)Math.cos(pl.angle)-pl.radius);
		int y = (int)(gameDisc[pl.curDisc].pos.y+(gameDisc[pl.curDisc].radius-pl.riseOffset)*(float)Math.sin(pl.angle)-pl.radius);

		//do the transformation on the FB image
                AffineTransform trans = new AffineTransform();
                BufferedImage bi = toBufferedImage(fbImage[pl.mode][pl.getCurAnimFrame()]);
                Graphics2D g2b = bi.createGraphics();
                //trans.setToIdentity();
                trans.rotate(pl.angle+Math.PI/2, (int)pl.radius, (int)pl.radius);
                //trans.translate((int)fb.pos.x, (int)fb.pos.y);
                g2b.transform(trans);
                AffineTransformOp transOp = new AffineTransformOp(trans, 2);

		g2d.drawImage(fbImage[pl.mode][pl.getCurAnimFrame()], transOp, (int)x, (int)y);
		//g.drawImage(fbImage[0][0], (int)(x-pl.radius), (int)(y-pl.radius), this);
		//g2d.drawImage(fbImage[0][0], transOp, (int)x, (int)y, this);
                //g2.drawImage(fbImage[0][0], zBufferSprite[i].imgOp, (int)zBufferSprite[i].x-zBufferSprite[i].w2, (int)(zBufferSprite[i].y-zBufferSprite[i].z)-zBufferSprite[i].h2);
	}

	//draw FB's left hand
	void playerFBLeftHandDisplay(Graphics2D g2d, player pl)
	{
		//int x = (int)(gameDisc[pl.curDisc].pos.x+gameDisc[pl.curDisc].radius*(float)Math.cos(pl.angle+pl.arcRadius+Math.PI/32)-fistRadius);
		//int y = (int)(gameDisc[pl.curDisc].pos.y+gameDisc[pl.curDisc].radius*(float)Math.sin(pl.angle+pl.arcRadius+Math.PI/32)-fistRadius);
		int x = (int)(gameDisc[pl.curDisc].pos.x+gameDisc[pl.curDisc].radius*(float)Math.cos(pl.angle+pl.arcRadius)-fistRadius);
		int y = (int)(gameDisc[pl.curDisc].pos.y+gameDisc[pl.curDisc].radius*(float)Math.sin(pl.angle+pl.arcRadius)-fistRadius);
                AffineTransform trans = new AffineTransform();
                BufferedImage bi = toBufferedImage(fbHandImage[0]);
                Graphics2D g2b = bi.createGraphics();
                //trans.setToIdentity();
                trans.rotate(pl.angle+pl.arcRadius+Math.PI/2, (int)fistRadius, (int)fistRadius);
                //trans.translate((int)fb.pos.x, (int)fb.pos.y);
                g2b.transform(trans);
                AffineTransformOp transOp = new AffineTransformOp(trans, 2);
		g2d.drawImage(fbHandImage[0], transOp, (int)x, (int)y);

		if(debugOn)
		{
			g2d.setColor(Color.YELLOW);
			g2d.drawOval(x+fistRadius/2, y+fistRadius/2, fistRadius, fistRadius);
		}
	}

	//draw FB's right hand
	void playerFBRightHandDisplay(Graphics2D g2d, player pl)
	{
		//int x = (int)(gameDisc[pl.curDisc].pos.x+gameDisc[pl.curDisc].radius*(float)Math.cos(pl.angle-pl.arcRadius-Math.PI/128)-fistRadius);
		//int y = (int)(gameDisc[pl.curDisc].pos.y+gameDisc[pl.curDisc].radius*(float)Math.sin(pl.angle-pl.arcRadius-Math.PI/128)-fistRadius);
		int x = (int)(gameDisc[pl.curDisc].pos.x+gameDisc[pl.curDisc].radius*(float)Math.cos(pl.angle-pl.arcRadius+Math.PI/64)-fistRadius);
		int y = (int)(gameDisc[pl.curDisc].pos.y+gameDisc[pl.curDisc].radius*(float)Math.sin(pl.angle-pl.arcRadius+Math.PI/64)-fistRadius);
                AffineTransform trans = new AffineTransform();
                BufferedImage bi = toBufferedImage(fbHandImage[1]);
                Graphics2D g2b = bi.createGraphics();
                //trans.setToIdentity();
                trans.rotate(pl.angle-pl.arcRadius+Math.PI/2, (int)fistRadius, (int)fistRadius);
                //trans.translate((int)fb.pos.x, (int)fb.pos.y);
                g2b.transform(trans);
                AffineTransformOp transOp = new AffineTransformOp(trans, 2);
		g2d.drawImage(fbHandImage[1], transOp, (int)x, (int)y);

		if(debugOn)
		{
			g2d.setColor(Color.YELLOW);
			g2d.drawOval(x+fistRadius/2, y+fistRadius/2, fistRadius, fistRadius);
		}
	}

	//draw the filled player arc for underneath the disc...
	void playerArcDisplayFilled(Graphics2D g2d, player pl)
	{
		int arcThickness = 5;
		int x = (int)(gameDisc[MAIN_DISC].pos.x-gameDisc[MAIN_DISC].radius); //+gameDisc[pl.curDisc].radius*(float)Math.cos(pl.angle-(float)Math.PI/48));
		int y = (int)(gameDisc[MAIN_DISC].pos.y-gameDisc[MAIN_DISC].radius); //+gameDisc[pl.curDisc].radius*(float)Math.sin(pl.angle-(float)Math.PI/48));

		g2d.setColor(new Color(213, 0, 0));
		g2d.fillArc(x-arcThickness, y-arcThickness, ((int)gameDisc[MAIN_DISC].radius+arcThickness)*2, ((int)gameDisc[MAIN_DISC].radius+arcThickness)*2, (int)Math.toDegrees(-pl.angle-pl.arcRadius), (int)Math.toDegrees(pl.arcRadius*2));
		g2d.setColor(Color.BLACK);
		g2d.drawArc(x-arcThickness-1, y-arcThickness-1, ((int)gameDisc[MAIN_DISC].radius+arcThickness+1)*2, ((int)gameDisc[MAIN_DISC].radius+arcThickness+1)*2, (int)Math.toDegrees(-pl.angle-pl.arcRadius), (int)Math.toDegrees(pl.arcRadius*2));
	}

	//draw the player's arc
	void playerArcDisplay(Graphics2D g2d, player pl)
	{
		//draw the red arc
		int x = (int)(gameDisc[MAIN_DISC].pos.x-gameDisc[MAIN_DISC].radius); //+gameDisc[pl.curDisc].radius*(float)Math.cos(pl.angle-(float)Math.PI/48));
		int y = (int)(gameDisc[MAIN_DISC].pos.y-gameDisc[MAIN_DISC].radius); //+gameDisc[pl.curDisc].radius*(float)Math.sin(pl.angle-(float)Math.PI/48));

		//draw the fists/hands at the ends of the arc
		//first fist...
		playerFBLeftHandDisplay(g2d, pl);
		//second fist...
		playerFBRightHandDisplay(g2d, pl);

		if(!debugOn) return;

		int lx = (int)(gameDisc[pl.curDisc].pos.x+gameDisc[pl.curDisc].radius*(float)Math.cos(pl.angle-pl.arcRadius+Math.PI/32));
		int ly = (int)(gameDisc[pl.curDisc].pos.y+gameDisc[pl.curDisc].radius*(float)Math.sin(pl.angle-pl.arcRadius+Math.PI/32));
		int rx = (int)(gameDisc[pl.curDisc].pos.x+gameDisc[pl.curDisc].radius*(float)Math.cos(pl.angle+pl.arcRadius-Math.PI/32));
		int ry = (int)(gameDisc[pl.curDisc].pos.y+gameDisc[pl.curDisc].radius*(float)Math.sin(pl.angle+pl.arcRadius-Math.PI/32));

		//draw some nodes
		//g2d.setColor(Color.BLUE);
		//g2d.fillRect(lx-5, ly-5, 10, 10);
		//g2d.fillRect(rx-5, ry-5, 10, 10);
	}

        //handle player drawing stuff
        void playerDisplay(Graphics2D g2d, player pl)
        {
		//draw the marble ring..
		//playerMarbleDisplay(g, pl);

		//draw a highlighted arc from the center of the disc to the player...
		int[] x = new int[4], y = new int[4];
		float suckAng = (float)DEFAULT_SUCK_DRAW_RADIUS;
		x[0] = (int)gameDisc[pl.curDisc].pos.x; y[0] = (int)gameDisc[pl.curDisc].pos.y;
		x[1] = (int)(gameDisc[pl.curDisc].pos.x+gameDisc[pl.curDisc].radius*(float)Math.cos(pl.angle-suckAng)); y[1] = (int)(gameDisc[pl.curDisc].pos.y+gameDisc[pl.curDisc].radius*(float)Math.sin(pl.angle-suckAng));
		x[2] = (int)(gameDisc[pl.curDisc].pos.x+gameDisc[pl.curDisc].radius*(float)Math.cos(pl.angle+suckAng)); y[2] = (int)(gameDisc[pl.curDisc].pos.y+gameDisc[pl.curDisc].radius*(float)Math.sin(pl.angle+suckAng));
		x[3] = x[0]; y[3] = y[0];
		g2d.setColor(playerHighlightColor);
		g2d.drawLine(x[0], y[0], x[1], y[1]);
		g2d.drawLine(x[0], y[0], x[2], y[2]);

		//draw the suck lines if we're sucking
		if(pl.isSucking())
		{
			//int numSpaces = (int)DEFAULT_SUCK_LENGTH/DEFAULT_SUCK_SPACING;
			int numSpaces = (int)suckLength/DEFAULT_SUCK_SPACING;

			for(int i = 0; i < numSpaces; i++)
			{
				int slx = (int)(gameDisc[pl.curDisc].pos.x+(gameDisc[pl.curDisc].radius-i*DEFAULT_SUCK_SPACING+suckCounter)*(float)Math.cos(pl.angle-suckAng));
				int sly = (int)(gameDisc[pl.curDisc].pos.y+(gameDisc[pl.curDisc].radius-i*DEFAULT_SUCK_SPACING+suckCounter)*(float)Math.sin(pl.angle-suckAng));
				int srx = (int)(gameDisc[pl.curDisc].pos.x+(gameDisc[pl.curDisc].radius-i*DEFAULT_SUCK_SPACING+suckCounter)*(float)Math.cos(pl.angle+suckAng));
				int sry = (int)(gameDisc[pl.curDisc].pos.y+(gameDisc[pl.curDisc].radius-i*DEFAULT_SUCK_SPACING+suckCounter)*(float)Math.sin(pl.angle+suckAng));
				int ca = (int)gameDisc[pl.curDisc].pos.distance(new vertex(slx, sly))/4;

				//alpha diminishes further away from FB
				Color suckColor = new Color(255, 255, 255, ca);
				g2d.setColor(suckColor);

				if(gameDisc[pl.curDisc].pos.distance(new vertex(slx, sly)) <= gameDisc[pl.curDisc].radius) g2d.drawLine(slx, sly, srx, sry);
			}
		}

		//x[0] = (int)(gameDisc[pl.curDisc].pos.x+gameDisc[pl.curDisc].radius*(float)Math.cos(pl.angle)-pl.radius);
		//y[0] = (int)(gameDisc[pl.curDisc].pos.y+gameDisc[pl.curDisc].radius*(float)Math.sin(pl.angle)-pl.radius);
		//g2d.setColor(Color.BLACK);
		//g2d.fillOval(x[0], y[0], (int)pl.radius*2, (int)pl.radius*2);
		//g2d.setColor(new Color(40, 40, 40));
		//g2d.fillOval(x[0]+(int)pl.radius/2, y[0]+(int)pl.radius/2, (int)pl.radius, (int)pl.radius);

		if(!pl.isRising())
		{
			//draw Food Boy's arc/armspan
			playerArcDisplay(g2d, pl);

			//draw Food Boy's head
			playerFBDisplay(g2d, pl);
		}

		//draw a triangle on the player circle's edge to point inward..
		g2d.setColor(new Color(100, 0, 0));

		//g.setColor(Color.BLACK);
		//g.drawString("pQuad: [" + getQuadrant(pl.angle) + "]", 20, 20);
		//g.drawString("dQuad: [" + getQuadrant(pl.destAngle) + "]", 20, 40);

		//don't bother with anything else if game over...
		if(gameState == GAMESTATE_GAMEOVER) return;

		//draw the destination angle..
		if(mouseControls)
		{
			//g2d.setColor(Color.RED);
			g2d.setColor(playerHighlightColor);
			g2d.drawOval((int)(gameDisc[pl.curDisc].pos.x+gameDisc[pl.curDisc].radius*(float)Math.cos(pl.destAngle)-3), (int)(gameDisc[pl.curDisc].pos.y+gameDisc[pl.curDisc].radius*(float)Math.sin(pl.destAngle)-3), 6, 6);
		}

		if(!debugOn) return;

		//show the angles of the arc ends for debugging...
		g2d.setColor(Color.RED);
		int lx = (int)(gameDisc[pl.curDisc].pos.x+gameDisc[pl.curDisc].radius*(float)Math.cos(pl.angle-pl.arcRadius+Math.PI/32))-10;
		int ly = (int)(gameDisc[pl.curDisc].pos.y+gameDisc[pl.curDisc].radius*(float)Math.sin(pl.angle-pl.arcRadius+Math.PI/32))-10;
		int rx = (int)(gameDisc[pl.curDisc].pos.x+gameDisc[pl.curDisc].radius*(float)Math.cos(pl.angle+pl.arcRadius-Math.PI/32))-10;
		int ry = (int)(gameDisc[pl.curDisc].pos.y+gameDisc[pl.curDisc].radius*(float)Math.sin(pl.angle+pl.arcRadius-Math.PI/32))-10;
		g2d.drawString("(" + (int)Math.toDegrees(pl.angle-pl.arcRadius) + ")[" + (int)Math.toDegrees(angleMod(pl.angle-pl.arcRadius)) + "]", lx, ly);
		g2d.drawString("(" + (int)Math.toDegrees(pl.angle+pl.arcRadius) + ")[" + (int)Math.toDegrees(angleMod(pl.angle+pl.arcRadius)) + "]", rx, ry);
		//g2d.drawString("(" + (int)Math.toDegrees(angleMod(pl.angle-pl.arcRadius)) + ")", lx, ly);
		//g2d.drawString("(" + (int)Math.toDegrees(angleMod(pl.angle+pl.arcRadius)) + ")", rx, ry);
        }

        //handle player drawing stuff
        void playerDisplayAll(Graphics2D g2d, player pl[], int num)
        {
		for(int i = 0; i < num; i++)
		{
			if(pl[i] == null || pl[i].isInactive()) continue;
			playerDisplay(g2d, pl[i]);
		}
        }

	//draw a single disc
	void discDisplay(Graphics g, disc di, boolean outline)
	{
		//draw the outer radius first..
		if(di.oRadius > 0)
		{
			g.setColor(di.oColor);
			g.fillOval((int)(di.pos.x-di.radius-di.bulgeOffset), (int)(di.pos.y-di.radius-di.bulgeOffset), (int)(di.radius+di.bulgeOffset)*2, (int)(di.radius+di.bulgeOffset)*2);
		}
		g.setColor(di.color);
		g.fillOval((int)(di.pos.x-di.radius+di.oRadius-di.bulgeOffset), (int)(di.pos.y-di.radius+di.oRadius-di.bulgeOffset), (int)(di.radius-di.oRadius+di.bulgeOffset)*2, (int)(di.radius-di.oRadius+di.bulgeOffset)*2);

		//draw a black outline around the disc..
		if(outline)
		{
			g.setColor(Color.BLACK);
			g.drawOval((int)(di.pos.x-di.radius-di.bulgeOffset), (int)(di.pos.y-di.radius-di.bulgeOffset), (int)(di.radius+di.bulgeOffset)*2, (int)(di.radius+di.bulgeOffset)*2);
		}

		//draw the spin indicator
		if(di.isSpinning())
		{
			g.setColor(di.lColor);
			g.fillOval((int)(di.pos.x+(2*di.radius/3)*(float)Math.cos(di.angle)-di.radius/4), (int)(di.pos.y+(2*di.radius/3)*(float)Math.sin(di.angle)-di.radius/4), (int)di.radius/2, (int)di.radius/2);
		}

		//draw the arc queue
		if(gameState == GAMESTATE_TITLE || !debugOn) return;

		//find the integer values of the start/end angles for the suck arc
		int suckAng0 = (int)Math.toDegrees(angleMod(gamePlayer[0].angle-DEFAULT_SUCK_RADIUS));
		int suckAng1 = (int)Math.toDegrees(angleMod(gamePlayer[0].angle+DEFAULT_SUCK_RADIUS));

		for(int i = 0; i < 360; i++)
		{
			if(arcActive[i] != 0)
			{
				g.setColor(new Color(160, 160, 160));
				g.drawLine((int)di.pos.x, (int)di.pos.y, (int)(di.pos.x+di.radius*Math.cos(Math.toRadians(i))), (int)(di.pos.y+di.radius*Math.sin(Math.toRadians(i))));
			}
		}
	}

	//draw the disc stack..
	void discDisplayAll(Graphics g, disc di[], int num)
	{
		for(int i = 0; i < num; i++)
		{
			if(di[i] == null) continue;
			discDisplay(g, di[i], true);
		}
	}

	//handle drawing this marble..
	void marbleDisplay(Graphics g, marble mb)
	{
		//draw a shadow beneath the food/marble
		g.setColor(new Color(0, 0, 0, 30));
		g.fillOval((int)(mb.pos.x-mb.radius+2), (int)(mb.pos.y-mb.radius+2), (int)mb.radius*2, (int)mb.radius*2);

		if(mb.isBomb())
		{
			if(!mb.isExploding()) g.drawImage(bombImage[mb.getAnimFrame()], (int)(mb.pos.x-mb.radius), (int)(mb.pos.y-mb.radius), this);
			else g.drawImage(explodeImage[mb.getAnimFrame()], (int)(mb.pos.x-mb.radius), (int)(mb.pos.y-mb.radius), this);
		}
		else if(marbleImage[mb.getColor()] == null)
		{
			//draw the marble body..
			g.setColor(marbleColor[mb.getColor()]);
			g.fillOval((int)(mb.pos.x-mb.radius), (int)(mb.pos.y-mb.radius), (int)mb.radius*2, (int)mb.radius*2);
			//draw a shiny on the upper corner..
			g.setColor(marbleColor[mb.getColor()].brighter());
			g.fillRect((int)mb.pos.x-6, (int)mb.pos.y-6, 4, 4);
		}
		else
		{
			if(debugOn)
			{
				g.setColor(marbleColor[mb.getColor()]);
				g.fillOval((int)(mb.pos.x-mb.radius), (int)(mb.pos.y-mb.radius), (int)mb.radius*2, (int)mb.radius*2);
			}

			if(!mb.isExploding()) g.drawImage(marbleImage[mb.getColor()], (int)(mb.pos.x-mb.radius), (int)(mb.pos.y-mb.radius), this);
			else g.drawImage(splatImage[mb.getAnimFrame()], (int)(mb.pos.x-mb.radius), (int)(mb.pos.y-mb.radius), this);
		}

		if(!debugOn) return;

		//debugging to show current angle of food
		g.setColor(new Color(255, 50, 50));
		String tempStr = new String();
		if(mb.pos.distance(gameDisc[0].pos) > gameDisc[0].radius) tempStr = ">";
		else if(mb.pos.distance(gameDisc[0].pos) < gameDisc[0].radius) tempStr = "<";
		else if(mb.pos.distance(gameDisc[0].pos) == gameDisc[0].radius) tempStr = "=";
		g.drawString("(" + (int)Math.toDegrees(angleMod(mb.angle)) + ")[" + (int)mb.pos.distance(gameDisc[0].pos) + tempStr + (int)gameDisc[0].radius + "]", (int)mb.pos.x-10, (int)mb.pos.y-10);
		//show whether this is within the arcspan
		float ang0 = gamePlayer[0].angle-gamePlayer[0].arcRadius;
		float ang1 = gamePlayer[0].angle+gamePlayer[0].arcRadius;
		//if(angleIsBetween(angleMod(mb.angle), gamePlayer[0].angle-gamePlayer[0].arcRadius, gamePlayer[0].angle+gamePlayer[0].arcRadius))
		//if(Math.toDegrees(angleMod(mb.angle)) >= Math.toDegrees(angleMod(gamePlayer[0].angle-gamePlayer[0].arcRadius)) && Math.toDegrees(angleMod(mb.angle)) <= Math.toDegrees(angleMod(gamePlayer[0].angle+gamePlayer[0].arcRadius+Math.PI/64)))
		if(angleIsWithinArc(angleMod(mb.angle), gamePlayer[0].angle-gamePlayer[0].arcRadius, gamePlayer[0].arcRadius*2))
		{
			g.setColor(Color.YELLOW);
			g.drawRect((int)(mb.pos.x-DEFAULT_MARBLE_RADIUS), (int)(mb.pos.y-DEFAULT_MARBLE_RADIUS), (int)DEFAULT_MARBLE_RADIUS*2, (int)DEFAULT_MARBLE_RADIUS*2);
		}
		//if(angleIsWithinArc(angleMod(mb.angle), gamePlayer[0].angle-DEFAULT_SUCK_RADIUS, DEFAULT_SUCK_RADIUS*2))
		if(isWithinSuckBounds(mb.angle))
		{
			//System.out.println("" + (int)Math.toDegrees(gamePlayer[0].angle-DEFAULT_SUCK_RADIUS) + " <= " + (int)Math.toDegrees(angleMod(mb.angle)) + " <= " + (int)Math.toDegrees(gamePlayer[0].angle+DEFAULT_SUCK_RADIUS));
			g.setColor(Color.WHITE);
			g.drawRect((int)(mb.pos.x-DEFAULT_MARBLE_RADIUS)-4, (int)(mb.pos.y-DEFAULT_MARBLE_RADIUS)-4, (int)DEFAULT_MARBLE_RADIUS*2+8, (int)DEFAULT_MARBLE_RADIUS*2+8);
		}

		/*
		int s = angleIsWithinArcDebug(angleMod(mb.angle), gamePlayer[0].angle-gamePlayer[0].arcRadius, gamePlayer[0].arcRadius);
		int t = angleIsWithinArcDebug(angleMod(mb.angle), gamePlayer[0].angle, gamePlayer[0].arcRadius);
		if(s != 0)
		{
			g.setColor(s == 1 ? Color.YELLOW : Color.WHITE);
			g.drawRect((int)(mb.pos.x-DEFAULT_MARBLE_RADIUS), (int)(mb.pos.y-DEFAULT_MARBLE_RADIUS), (int)DEFAULT_MARBLE_RADIUS*2, (int)DEFAULT_MARBLE_RADIUS*2);
			g.drawRect((int)(mb.pos.x-DEFAULT_MARBLE_RADIUS)-1, (int)(mb.pos.y-DEFAULT_MARBLE_RADIUS)-1, (int)DEFAULT_MARBLE_RADIUS*2+2, (int)DEFAULT_MARBLE_RADIUS*2+2);
		}
		if(t != 0)
		{
			g.setColor(t == 1 ? Color.RED : Color.BLACK);
			g.drawRect((int)(mb.pos.x-DEFAULT_MARBLE_RADIUS), (int)(mb.pos.y-DEFAULT_MARBLE_RADIUS), (int)DEFAULT_MARBLE_RADIUS*2, (int)DEFAULT_MARBLE_RADIUS*2);
			g.drawRect((int)(mb.pos.x-DEFAULT_MARBLE_RADIUS)-1, (int)(mb.pos.y-DEFAULT_MARBLE_RADIUS)-1, (int)DEFAULT_MARBLE_RADIUS*2+2, (int)DEFAULT_MARBLE_RADIUS*2+2);
		}
		*/
	}

        //handle drawing the items
        void marbleDisplayAll(Graphics g, marble mb[], int num)
        {
		for(int i = 0; i < num; i++){
			if(mb[i] == null || mb[i].isInactive()) continue;
			marbleDisplay(g, mb[i]);
			}
        }

        //handle drawing the shots
        void projectileDisplayAll(Graphics g, projectile pr[], int num)
        {
		for(int i = 0; i < num; i++){
			if(pr[i] == null || pr[i].isInactive()) continue;
			g.setColor(Color.BLACK);
			g.fillRect((int)(pr[i].pos.x-pr[i].radius), (int)(pr[i].pos.y-pr[i].radius), (int)pr[i].radius*2, (int)pr[i].radius*2);
			}
        }

        //draw the grid overlay (if we use it?)
        void gridDisplay(Graphics g)
        {
        }

        //draw the scrolling backdrop
        void backgroundDisplay(Graphics g)
        {
		int wallH = 80;       //bg wall height

                //clear the background
                g.setColor(clearColor);
                g.fillRect(0, 0, playW, playH);
                //gridDisplay(g);

		//draw the floor and wall
		g.setColor(bgFloorColor);
		g.fillRect(0, wallH, playW, playH-wallH);
		g.setColor(bgWallColor);
		g.fillRect(0, 0, playW, wallH);
		g.setColor(new Color(0, 0, 0, 128));
		g.drawLine(0, wallH, playW, wallH);

		//draw the bg elements (trees, snow, etc.)
		g.drawImage(rugImage, -30, (int)bgTreePos.y+2*treeImage.getHeight()/3+5, this);

		//draw a light behind the "M" tree-topper
		int offT = 0;
		g.setColor(new Color(255, 255, 255, 10));
		g.fillOval((int)bgTreePos.x+treeImage.getWidth()/2-16-offT, 4, 40+offT*2, 40+offT*2);
		g.fillOval((int)bgTreePos.x+treeImage.getWidth()/2-18-offT, 2, 44+offT*2, 44+offT*2);
		g.drawImage(treeImage, (int)bgTreePos.x, (int)bgTreePos.y, this);

		//draw a flickering light beneath the fireplace...
		int offX = getFireAnimFrame()*2;
		g.setColor(new Color(255, 255, 255, 5+5*getFireAnimFrame()/MAX_FIREPLACE_ANIMS));
		g.fillRect((int)bgFireplacePos.x-offX, wallH+5, fireplaceImage.getWidth()+offX*2, 20+offX);

		g.drawImage(fireplaceImage, (int)bgFireplacePos.x, (int)bgFireplacePos.y, this);

		//draw a flickering light in the back of the fireplace...
		g.setColor(new Color(255, 255, 255, 10+40*getFireAnimFrame()/MAX_FIREPLACE_ANIMS));
		g.fillRect((int)bgFireplacePos.x+fireplaceImage.getWidth()/2-25, (int)bgFireplacePos.y+35, 50, 45);

		g.drawImage(fireImage[getFireAnimFrame()], (int)bgFirePos.x, (int)bgFirePos.y, this);

		//draw the sky first...
		g.setColor(bgSkyColor);
//		g.fillRect((int)bgWindowPos.x+10, 0, (int)windowImage.getWidth()-20, (int)windowImage.getHeight()-5);
		g.fillRect((int)bgSkyPos.x, (int)bgSkyPos.y, skyW, skyH);

		//draw the snowfall..
		snowDisplay(g, snow, numSnowFlakes);

		//draw the window over the sky
		g.drawImage(windowImage, (int)bgWindowPos.x, (int)bgWindowPos.y, this);

                //draw the black border around the play area
                //g.setColor(Color.black);
                //g.drawRect((int)playFieldPos.x, (int)playFieldPos.y, playW, playH);
        }

	//draw the score, level status, etc.
	void playerHudDisplay(Graphics g, player pl)
	{
		if(!hudOn) return;

		//String msg = "Score: " + longNumberString(pl.score, 6) + ", Streak: " + intNumberString(pl.curStreak, 3) + ", Best Streak: " + intNumberString(pl.bestStreak, 3);
		g.setFont(hudFont);
		String msg = "Score: " + longNumberString(pl.score, 6);
		drawStringShadowed(g, msg, Color.WHITE, (int)hudPos.x, (int)hudPos.y, 2, 2);
		msg = "Hi: " + longNumberString(curHiScore, 6);
		drawStringShadowed(g, msg, Color.WHITE, (int)hudPos.x+(fancyFont ? fontW*4-2 : fontW*3), (int)hudPos.y+(fancyFont ? 3*fontH/2 : fontH), 2, 2);
		msg = "Level: " + intNumberString(curLevel, 2);
		drawStringShadowed(g, msg, Color.WHITE, (int)hudPos.x, (int)hudPos.y+(fancyFont ? 3*fontH/2+fontH+5 : 2*fontH), 2, 2);

		/*
		g.setColor(Color.BLACK);
		g.drawString("Score: " + longNumberString(pl.score, 6) + ", Streak: " + intNumberString(pl.curStreak, 3) + ", Best Streak: " + intNumberString(pl.bestStreak, 3), (int)hudPos.x, (int)hudPos.y);
		g.drawString("Arc: [" + (int)Math.toDegrees(pl.arcRadius*2) + " / 360]", (int)hudPos.x, (int)hudPos.y+fontH);
		g.drawString("Level: " + intNumberString(curLevel, 2), (int)hudPos.x, (int)hudPos.y+fontH*2);
		g.setColor(Color.WHITE);
		g.drawString("Score: " + longNumberString(pl.score, 6) + ", Streak: " + intNumberString(pl.curStreak, 3) + ", Best Streak: " + intNumberString(pl.bestStreak, 3), (int)hudPos.x-1, (int)hudPos.y-1);
		g.drawString("Arc: [" + (int)Math.toDegrees(pl.arcRadius*2) + " / 360]", (int)hudPos.x-1, (int)hudPos.y+fontH-1);
		g.drawString("Level: " + intNumberString(curLevel, 2), (int)hudPos.x-1, (int)hudPos.y+fontH*2-1);
		*/
	}

        //draw the hud/status stuff
        void foregroundDisplay(Graphics g)
        {
		g.setFont(gameFont);
		g.setColor(Color.BLACK);
		drawStringRightAligned(g, versionString, playW, playH-2);
		g.setColor(Color.WHITE);
		drawStringRightAligned(g, versionString, playW-2, playH-2-2);
        }

        //draw the title screen
        void titleDisplay(Graphics g)
        {
		//draw the logo
		g.drawImage(logoImage, playW/2-logoImage.getWidth()/2, (int)(logoPos.y+logoYOffset), this);

		//draw "click anywhere to start" prompt
		String msg = new String("Click anywhere to begin");
		g.setFont(gameFontBig);
		drawStringShadowed(g, msg, Color.WHITE, playW/2-fontBigW*msg.length()/2, 70, 2, 2);
		g.setFont(gameFont);

		//draw the hiscore stuff
		hiScoreListingDisplay(g);
        }

        //draw the hiscore listing box
        void hiScoreListingDisplay(Graphics g)
        {
		String msg = "Top Scores";
		g.setFont(gameFont);
		drawStringShadowed(g, msg, Color.WHITE, playW/2-fontW*msg.length()/2, playH/2+fontH*3, 2, 2);
		for(int i = 0; i < gameHiScoreBank.numScores; i++)
		{
			//set the most recent score to white to make it stand out...
			Color col = (gameHiScoreBank.score[i].isCurrent ? Color.WHITE : new Color(230, 230, 230));
			if(gameHiScoreBank.score[i] == null) continue;
			//draw a highlight bar around the player's score if he's got one...
			if(gameHiScoreBank.score[i].isCurrent)
			{
				g.setColor(new Color(255, 255, 255, 20));
				g.fillRect(100-1, playH/2+fontH*3+(fontH+2*fontH/3)*i, 100+MAX_PLAYER_NAME_LENGTH*fontW, fontH*2);
			}
			msg = "" + gameHiScoreBank.score[i].name;
			drawStringShadowed(g, msg, col, 100, playH/2+fontH*3+(fontH+2*fontH/3)*(i+1), 2, 2);
			msg = "" + gameHiScoreBank.score[i].score;
			drawStringShadowed(g, msg, col, 100+MAX_PLAYER_NAME_LENGTH*fontW, playH/2+fontH*3+(fontH+2*fontH/3)*(i+1), 2, 2);
			//msg = "" + gameHiScoreBank.score[0][0].score;
			//drawStringShadowed(g, msg, Color.WHITE, playW/2-fontW*msg.length()/2, playH/2+fontH*3+fontH*(i+1), 2, 2);
		}
        }

        //tells if the hiscores list is currently showing
        boolean hiScoresListShowing()
        {
                return !gotHiScore && hiScoreEntryDone;
        }

        //draw the hiscore entry box
        void hiScoreEntryDisplay(Graphics g)
        {
		int startY = 180;
		//draw a translucent box over the background
		g.setColor(new Color(255, 255, 255, 50));
		g.fillRect(100, startY, playW-200, 100);
		g.setColor(new Color(255, 255, 255, 200));
		g.drawRect(100, startY, playW-200, 100);
		String msg = "You got a high score!";
                g.setFont(gameFont);
		drawStringShadowed(g, msg, Color.WHITE, playW/2-fontW*msg.length()/2, startY+fontH+fontH/2, 2, 2);
		msg = "Enter your name for posterity:";
		drawStringShadowed(g, msg, new Color(220, 220, 220), playW/2-fontW*msg.length()/2, startY+fontH*4, 2, 2);
		g.setColor(new Color(0, 0, 0, 180));
		g.fillRect(140, startY+fontH*6, MAX_PLAYER_NAME_LENGTH*fontW, fontH*2);
		drawStringShadowed(g, playerNameString + "_", Color.WHITE, 150, startY+fontH*7+fontH/2, 2, 2);
        }

        //draw the game over screen
        void gameOverDisplay(Graphics g)
        {
		//draw the game over image
		g.drawImage(gameOverImage, (int)gameOverPos.x, (int)gameOverPos.y, this);

		//draw "click anywhere to restart" prompt
		String msg = new String("Click anywhere to play again");
		g.setFont(gameFontBig);
		drawStringShadowed(g, msg, Color.WHITE, playW/2-fontBigW*msg.length()/2, 30, 2, 2);
		g.setFont(gameFont);

		//draw the hiscore stuff
		if(!gotHiScore && hiScoreEntryDone) hiScoreListingDisplay(g);
		else if(gotHiScore && !hiScoreEntryDone) hiScoreEntryDisplay(g);
        }

        //display method (run() calls this each frame)
        void paintApp(Graphics g)
        {
	        Graphics2D g2d = (Graphics2D)g_scBuff;

                backgroundDisplay(g_scBuff);

                switch(gameState)
		{
                        case GAMESTATE_TITLE: //draw the title screen
				discDisplay(g_scBuff, gameDisc[MAIN_DISC], true);
                                titleDisplay(g_scBuff);

                                break;
                        case GAMESTATE_READY:
				//discDisplayAll(g_scBuff, gameDisc, numDiscs);

				//draw Food Boy's head for the rising
				if(gamePlayer[0].isRising()) playerFBDisplay(g2d, gamePlayer[0]);

				if(!gamePlayer[0].isRising()) playerArcDisplayFilled(g2d, gamePlayer[0]);                   //draw the arc beneath the disc so we can fill it...
				discDisplay(g_scBuff, gameDisc[MAIN_DISC], true);
                                //playerDisplayAll(g2d, g_scBuff, gamePlayer, numPlayers);
                                playerDisplayAll(g2d, gamePlayer, numPlayers);
				marbleDisplayAll(g_scBuff, gameMarble, numMarbles);
				projectileDisplayAll(g_scBuff, gameProjectile, numProjectiles);

				discDisplay(g_scBuff, gameDisc[CENTER_DISC], false);
				santaDisplay(g2d);

				playerHudDisplay(g_scBuff, gamePlayer[0]);

				particleDisplay(g_scBuff, gameParticleBank);

				//draw the "paused" indicator if we're paused
				if(paused)
				{
					String msg = new String("Game paused");
					g2d.setFont(gameFontBig);
					drawStringShadowed(g2d, msg, Color.WHITE, playW/2-fontBigW*msg.length()/2, playH/2, 2, 2);
				}

                                break;
                        case GAMESTATE_GAMEOVER: //draw the game over screen
				discDisplay(g_scBuff, gameDisc[MAIN_DISC], true);
                                playerDisplayAll(g2d, gamePlayer, numPlayers);
				marbleDisplayAll(g_scBuff, gameMarble, numMarbles);
				projectileDisplayAll(g_scBuff, gameProjectile, numProjectiles);

				discDisplay(g_scBuff, gameDisc[CENTER_DISC], false);
				santaDisplay(g2d);

				playerHudDisplay(g_scBuff, gamePlayer[0]);

				particleDisplay(g_scBuff, gameParticleBank);

                                gameOverDisplay(g_scBuff);

                                break;
                        default:
                                break;
		}

                //draw the status/hud, etc.
                //foregroundDisplay(g_scBuff);

                //draw the screen buffer to screen
                g.drawImage(img_scBuff, 0, 0, this);
        }


	//add another disc to the stack..
	void addDisc(vertex coords, vertex vCoords, Color col, Color lcol, Color ocol, float rad, float oRad, float a, float av)
	{
		gameDisc[numDiscs++] = new disc(coords, vCoords, col, lcol, ocol, rad, oRad, a, av);
	}

	//handle collisions with player marbles, etc.
	void handlePlayerMarbleInteraction(player pl, marble mb[], int num)
	{
		for(int i = 0; i < num; i++)
		{
			if(mb[i] == null || mb[i].isInactive()) continue;
			if(mb[i].isActive())
			{
				//find distance between marble and FB
				float distF = mb[i].pos.distance(pl.pos);

				//find distance between marble and disc's center
				float distC = mb[i].pos.distance(gameDisc[0].pos);

				//see if player is sucking...
				if(pl.isSucking())
				{
					//if the food is within the arc area/cone that FB's suck influences and it's not on the rebound, start pulling it toward mouth
					//if(Math.toDegrees(pl.angle) >= Math.toDegrees(mb[i].angle)-5 && Math.toDegrees(pl.angle) <= Math.toDegrees(mb[i].angle)+5)
					//if(angleIsWithinArc(angleMod(mb[i].angle), pl.angle-DEFAULT_SUCK_RADIUS, DEFAULT_SUCK_RADIUS*2))
					if(!mb[i].returning && isWithinSuckBounds(mb[i].angle))
					{
						//don't bother if distance is too great...
						if(distF >= suckLength) continue;

						//the food's acceleration while sucked depends on how far it is from FB
						float accel = 0.05f*(distF/32);

						mb[i].vel.x += accel*Math.cos(mb[i].angle);
						mb[i].vel.y += accel*Math.sin(mb[i].angle);
					}
				}

				//marble has gone beyond the outer rim..
				//if(!mb[i].pos.circleCollision(gameDisc[pl.curDisc].pos, mb[i].radius, gameDisc[pl.curDisc].radius+pl.radius))
				//if(!mb[i].pos.circleCollision(gameDisc[pl.curDisc].pos, mb[i].radius, gameDisc[pl.curDisc].radius+pl.radius))
				if(distC > gameDisc[pl.curDisc].radius+mb[i].radius)
				{
					//if it's food, hurt the player
					if(!mb[i].isBomb())
					{
						pl.clearStreak();
						if(pl.decreaseArcRadius(player.DEFAULT_MARBLE_ARC_RADIUS*3) != 0)
						{
							pl.kill();
							beginGameOverSequence();
						}

						//start splat animation
						mb[i].setToExploding();
						playSmashSound();
					}
					//if it's a bomb, blow it up
					else
					{
						//start exploding animation
						mb[i].setToExploding();
						playExplosionSound();
					}

					continue;
				}

				//see if marble is close to the outer edge of the disc
				if(!mb[i].pos.circleCollision(gameDisc[pl.curDisc].pos, mb[i].radius, gameDisc[pl.curDisc].radius-pl.radius-mb[i].radius*2))
				{
					//if so, check for collision with player and his marbles..

					//don't bother if we're beyond the middle of FB...
					//if(mb[i].pos.distance(gameDisc[pl.curDisc].pos) > gameDisc[pl.curDisc].radius) continue;
					if(distC > gameDisc[pl.curDisc].radius) continue;

					//calculate the player's position
					vertex plPos = new vertex(gameDisc[pl.curDisc].pos.x+gameDisc[pl.curDisc].radius*(float)Math.cos(pl.angle), gameDisc[pl.curDisc].pos.y+gameDisc[pl.curDisc].radius*(float)Math.sin(pl.angle));

					//if marble touches the player, eat it
					if(mb[i].pos.circleCollision(plPos, mb[i].radius, pl.radius))
					{
						int frame = 0;

						//if we're sucking currently, stop suck, but keep animation set for less choppiness
						if(pl.isSucking())
						{
							frame = pl.getSuckFrame();
							pl.stopSuck();
							stillSucking = false;
						}

						//don't do anything while ouched...
						if(pl.isOuched()) continue;

						//increase player's arc length on non-bombs, decrease on bombs
						if(!mb[i].isBomb())
						{
							//deactivate marble
							mb[i].deactivate();

							//start chomp animation
							pl.startChomp();
							pl.setAnimFrame(frame);

							//pl.score += mb[i].getPointValue();
							addToPlayerScore(pl, mb[i].getPointValue());
							gameParticleBank.addParticle(new vertex(mb[i].pos.x-DEFAULT_MARBLE_RADIUS*2, mb[i].pos.y-DEFAULT_MARBLE_RADIUS*2), new vertex(0, -0.5f), "" + mb[i].getPointValue() + "pts", gameFont, new Color(210, 243, 241), 0, 0, particle.SHAPE_TEXT, 40);
							playChompSound();

							pl.expandArcRadius();
							pl.addToStreak();

							//pop a message on the screen if we've hit certain streak thresholds...
							if(pl.curStreak % FOOD_STREAK_THRESHOLD == 0 && pl.curStreak > 0)
							{
								gameParticleBank.addParticle(new vertex(mb[i].pos.x-DEFAULT_MARBLE_RADIUS*2, mb[i].pos.y-DEFAULT_MARBLE_RADIUS*2+fontH+5), new vertex(0, -0.5f), "" + pl.curStreak + " in a row!", gameFont, new Color(210, 243, 241), 0, 0, particle.SHAPE_TEXT, 60);
							}

							//level up when the arc is filled
							if(pl.arcFilled()) levelUp = true;
						}
						else
						{
							//start explosion if bomb
							mb[i].setToExploding();
							pl.clearStreak();
							playExplosionSound();

							//shorten the arc, and start ouch if arc still remains, kill FB otherwise
							if(pl.decreaseArcRadius(player.DEFAULT_MARBLE_ARC_RADIUS*3) == 0) pl.startOuch();
							else
							{
								beginGameOverSequence();
								pl.kill();
							}
						}

					}
				}
				//check to see if the marble is hitting FB's arc
				if(!mb[i].pos.circleCollision(gameDisc[pl.curDisc].pos, mb[i].radius, gameDisc[pl.curDisc].radius-mb[i].radius*2) && !mb[i].returning)
				{
					//if(mb[i].pos.distance(gameDisc[pl.curDisc].pos) > gameDisc[pl.curDisc].radius-mb[i].radius+2) continue;

					//System.out.println("Food #" + i + " with angle " + (int) Math.toDegrees(mb[i].angle) + " is touching the outer edge... FB angle: " + (int)Math.toDegrees(pl.angle) + "deg");
					//make sure the food angle is within the arc
					if(angleIsWithinArc(angleMod(mb[i].angle), pl.angle-pl.arcRadius, pl.arcRadius*2))
					//if(Math.toDegrees(mb[i].angle) >= Math.toDegrees(pl.angle-pl.arcRadius) && Math.toDegrees(mb[i].angle) <= Math.toDegrees(pl.angle+pl.arcRadius+Math.PI/64))
					{
						System.out.println("Food #" + i + " within FB arc..");
						//bounce the food back
						//something is wrong here... need to fix this...
						mb[i].bounce();
						playBounceSound();

						//increase the multiplier if it's not a bomb
						if(!mb[i].isBomb())
						{
							mb[i].increasePointMultiplier();

							//spawn an on-screen notification for the multiplier increase..
							gameParticleBank.addParticle(new vertex(mb[i].pos.x-mb[i].radius, mb[i].pos.y-mb[i].radius), new vertex(0, -0.5f), "x" + mb[i].pointMultiplier, gameFont, new Color(236, 182, 205), 0, 0, particle.SHAPE_TEXT, 40);
						}


						//spawn some particles on each bounce..
						float aRad;
						vertex pPos = new vertex(mb[i].pos.x+(float)Math.cos(mb[i].angle-(float)Math.PI)*mb[i].radius, mb[i].pos.y+(float)Math.sin(mb[i].angle-(float)Math.PI)*mb[i].radius);
						Color pColor = new Color(255, 255, 255, 200);

						//add some smoke puffs/particles...
						for(int j = 0; j < 4; j++)
						{
							aRad = (float)Math.random()*2.0f+1.0f;
							gameParticleBank.addParticle(pPos, new vertex(randNeg()*(float)Math.random()*0.5f+0.25f, randNeg()*(float)Math.random()*0.5f+0.25f), pColor, aRad, aRad, particle.SHAPE_CIRCLE_FILLED, 40, 3);
						}

						//make the arms/arc slightly shorter punitively..
						pl.decreaseArcRadius(player.DEFAULT_MARBLE_ARC_RADIUS/4);
					}
					//if(Math.toDegrees(pl.angle) >= Math.toDegrees(mb[i].angle)-5 && Math.toDegrees(pl.angle) <= Math.toDegrees(mb[i].angle)+5)

					continue;
				}
				//check for collisions between marbles and Santa Bot on the return
				if(mb[i].returning)
				{
					if(mb[i].pos.circleCollision(gameDisc[SANTA_DISC].pos, mb[i].radius, santaRadius))
					{
						if(mb[i].isBomb())
						{
							//explode the bomb when it hits Santa
							mb[i].setToExploding();
							playExplosionSound();

							//disable Santa Bot if he's not already disabled or if not he's victorious...
							if(santaMode == SANTA_MODE_NORMAL) santaMode = SANTA_MODE_DISABLED;
							//reset the disabled timer if Santa Bot is already disabled...
							else if(santaMode == SANTA_MODE_DISABLED) santaDisabledTimer = 0;

							//make Santa bulge a little
							gameDisc[SANTA_DISC].startBulging();
						}
						else
						{
							//bounce back off Santa if food
							mb[i].bounce();
							playBounceSound();
						}
					}
				}

			}
		}
	}

	//handle the player's marble clear list (add particles, etc.)
	void handlePlayerClearList(player pl)
	{
		for(int i = 0; i < pl.numToClear; i++){
			//get the player's marble positions yet again..
			float ang = pl.arcRadius+(pl.clearList[i])*pl.marbleArcRadius*2+pl.marbleArcRadius;
			float x = gameDisc[pl.curDisc].pos.x+gameDisc[pl.curDisc].radius*(float)Math.cos(pl.angle+ang);
			float y = gameDisc[pl.curDisc].pos.y+gameDisc[pl.curDisc].radius*(float)Math.sin(pl.angle+ang);
			gameParticleBank.addParticle(new vertex(x, y), new vertex(0.25f*(float)Math.cos(pl.angle+ang), 0.25f*(float)Math.sin(pl.angle+ang)), Color.WHITE, pl.marbleRadius, pl.marbleRadius, particle.SHAPE_CIRCLE, 40, 2);
			}
		pl.resetClearList();
	}

	//handle player ouch stuff
	void handlePlayerOuch(player pl)
	{
		if(pl.isOuched()) pl.doOuch();
	}

	//handle player sucking stuff
	void handlePlayerSucking(player pl)
	{
		if(pl.isSucking()) doPlayerSuck(pl);
	}

	//handle player chomping stuff
	void handlePlayerChomping(player pl)
	{
		if(pl.isChomping()) doPlayerChomp(pl);
	}

	//refresh the arc...
	void refreshPlayerArc(player pl)
	{
		//check to see if we're in arc-clear mode...
		if(pl.arcClearing) pl.clearArc();

		for(int i = 0; i < 360; i++) arcActive[i] = 0;
		int counter = 0;
		int ang = (int)Math.toDegrees(angleMod(pl.angle-pl.arcRadius));
		while(counter < (int)Math.toDegrees(pl.arcRadius)*2)
		{
			arcActive[ang] = 1;
			ang = (ang+1 >= 360 ? 0 : ang+1);
			counter++;
		}

		//set up suck arc
		counter = ang = 0;
		int suckAng0 = (int)Math.toDegrees(angleMod(pl.angle-DEFAULT_SUCK_RADIUS));
		ang = suckAng0;
		while(counter < (int)Math.toDegrees(DEFAULT_SUCK_RADIUS)*2)
		{
			arcActive[ang] = 2;
			ang = (ang+1 >= 360 ? 0 : ang+1);
			counter++;
		}

	}

	//add these points to the player score
	void addToPlayerScore(player pl, int points)
	{
		pl.score += points;
		if(pl.score >= curHiScore)
		{
			curHiScore = pl.score;
			if(hiScoreStatus == 0) hiScoreStatus = 1;
		}
	}

	//handle scoring-related stuff
	void handlePlayerScoreStuff(player pl)
	{
		if(hiScoreStatus == 1)
		{
			//spawn a "you got a hi score!" notification...
			String msg = new String("You've got the highest score!");
			gameParticleBank.addParticle(new vertex(playW/2-fontW*msg.length()/2, 40), new vertex(0, -0.2f), msg, gameFont, new Color(225, 243, 241), 0, 0, particle.SHAPE_TEXT, 100);
			playHiScoreSound();

			hiScoreStatus = 2;
		}
	}

        //handle player logic routines
        void playerLogic(player pl)
        {
		//check to see if we're in the quadrant 1 or 4, so we can handle the "edge" cases
		int angA = getQuadrant(pl.angle);
		int angB = getQuadrant(pl.destAngle);

		if(!pl.isRising() && !pl.isSettling())
		{

			if((angA == angB) || (angA == angB-1) || (angA == angB+1) || (angA == angB-2) || (angA == angB+2))
			{
				if(pl.angle > pl.destAngle+player.MAX_ANGLE_SPEED)
				{
					pl.rotateLeft(mouseControls);

					pl.stopped = false;
				}
				else if(pl.angle < pl.destAngle-player.MAX_ANGLE_SPEED)
				{
					pl.rotateRight(mouseControls);

					pl.stopped = false;
				}
				else pl.stopped = true;
			}
			else
			{
				//player in 1st quad, dest in 4th..
				if(angA == 1 && angB == 4)
				{
					if(pl.angle+(float)Math.PI*2 > pl.destAngle+player.MAX_ANGLE_SPEED)
					{
						pl.rotateLeft(mouseControls);

						pl.stopped = false;
					}
					else pl.stopped = true;
				}
				//player in 4th quad, dest in 1st..
				else if(angA == 4 && angB == 1)
				{
					if(pl.angle-(float)Math.PI*2 < pl.destAngle-player.MAX_ANGLE_SPEED)
					{
						pl.rotateRight(mouseControls);

						pl.stopped = false;
					}
					else pl.stopped = true;
				}
				else pl.stopped = true;
			}

			pl.move();
			refreshPlayerArc(pl);
			handlePlayerMarbleInteraction(pl, gameMarble, numMarbles);
			//handlePlayerClearList(pl);
			handlePlayerSucking(pl);
			handlePlayerChomping(pl);
			handlePlayerOuch(pl);
			handlePlayerScoreStuff(pl);
		}
		//rise till we get above the table..
		else if(pl.isRising())
		{
			pl.doRise();
		}
		else if(pl.isSettling())
		{
			pl.doSettle();
		}
        }

        //handle player logic routines
        void playerLogicAll(player pl[], int num)
        {
		for(int i = 0; i < num; i++)
		{
			playerLogic(pl[i]);
		}
        }

	//clear all the marbles on the board
	void clearMarbles()
	{
		int multiplier = 0;
		for(int i = 0; i < numMarbles; i++)
		{
			if(gameMarble[i] == null || gameMarble[i].isInactive()) continue;

			//explode/smush everything
			gameMarble[i].setToExploding();
			if(gameMarble[i].isBomb()) playExplosionSound();

			//deactivate the marble
			//gameMarble[i].deactivate();

			if(gameState == GAMESTATE_GAMEOVER) continue;

			//each marble deactivated increases the multiplier
			multiplier++;
			gameParticleBank.addParticle(new vertex(gameMarble[i].pos.x-gameMarble[i].radius, gameMarble[i].pos.y-gameMarble[i].radius-fontH), new vertex(0, -0.5f), "x" + multiplier, gameFont, new Color(236, 182, 205), 0, 0, particle.SHAPE_TEXT, 40);
			gameParticleBank.addParticle(new vertex(gameMarble[i].pos.x-gameMarble[i].radius, gameMarble[i].pos.y-gameMarble[i].radius), new vertex(0, -0.5f), "" + gameMarble[i].getPointValue()*multiplier + "pts", gameFont, new Color(210, 243, 241), 0, 0, particle.SHAPE_TEXT, 40);

			//add score to player's total
			addToPlayerScore(gamePlayer[0], gameMarble[i].getPointValue()*multiplier);
			//gamePlayer[0].score += gameMarble[i].getPointValue()*multiplier;
		}
	}

	//handle the interactions between marbles
	void handleMarbleMarbleInteraction(int slot, marble mb[], int num)
	{
		//if this is an explosion, look for nearby active bombs
		if(mb[slot].isExploding())
		{
			for(int i = 0; i < num; i++)
			{
				//don't bother with the current bomb or non-bombs or null objects
				if(i == slot || mb[i] == null || !mb[i].isBomb()) continue;

				//if bomb is active, check to see if we're touching it...
				if(mb[i].isActive())
				{
					if(mb[slot].pos.circleCollision(mb[i].pos, mb[slot].radius, mb[i].radius))
					{
						mb[i].setToExploding();
						playExplosionSound();
					}
				}
			}
		}
	}

        //handle all marble-related logic..
        void marbleLogic(marble mb[], int num)
        {
		for(int i = 0; i < num; i++)
		{
			if(mb[i] == null || mb[i].isInactive()) continue;
			mb[i].move();
			mb[i].animate();
			handleMarbleMarbleInteraction(i, mb, num);
		}
        }

	//check for collisions between this projectile and the marbles
	int handleProjectileMarbleInteraction(projectile pr, marble mb[], int num)
	{
		for(int m = 0; m < num; m++){
			if(mb[m] == null || mb[m].isInactive()) continue;
			if(pr.pos.circleCollision(mb[m].pos, pr.radius, mb[m].radius)){
				int numMatches;
				pr.kill();

				//spawn some particles..
				gameParticleBank.addParticle(mb[m].pos, new vertex(), Color.WHITE, mb[m].radius, mb[m].radius, particle.SHAPE_CIRCLE, 40, 3);
				gameParticleBank.addParticle(mb[m].pos, new vertex(), Color.WHITE, mb[m].radius/2, mb[m].radius/2, particle.SHAPE_CIRCLE, 40, 2);

				if(mb[m].isWildcard()){
					gamePlayer[0].useWildcardMarble(gamePlayer[0].numMarbles-1);
					mb[m].deactivate();
					numMatches = gamePlayer[0].checkForMarbleMatchesAll();
					if(numMatches > 0){
						//add some bonus points for each marble obtained..
						gamePlayer[0].score += (numMatches*50+curLevel*20);
						//see if we went over the levelup tally..
						checkForPlayerLevelUp(gamePlayer[0]);
						}

					continue;
					}

				gamePlayer[0].acquireMarble(mb[m]);

				//marble was acquired..
				//check for matches, deactivate the disc marble, then kill the shot
//				gamePlayer[0].checkForMarbleMatches(gamePlayer[0].numMarbles-1);
				numMatches = gamePlayer[0].checkForMarbleMatchesExt(gamePlayer[0].numMarbles-1);
				if(numMatches > 0){
					//add some bonus points for each marble obtained..
					gamePlayer[0].score += (numMatches*50+curLevel*20);
					//see if we went over the levelup tally..
					checkForPlayerLevelUp(gamePlayer[0]);
					}

				mb[m].deactivate();

				//if queue is now full, game is over!
				if(gamePlayer[0].marbleQueueFull()){
					gameState = GAMESTATE_GAMEOVER_BEGIN;
					}
				return -1;
				}
			}
		return 0;
	}

        //handle all shot-related logic..
        void projectileLogic(projectile pr[], int num)
        {
		for(int i = 0; i < num; i++)
		{
			if(pr[i] == null || pr[i].isInactive()) continue;
			pr[i].move();

			//if projectile hits the center, stop it so it can't go past..
			if(pr[i].pos.circleCollision(gameDisc[CENTER_DISC].pos, pr[i].radius, gameDisc[CENTER_DISC].radius))
			{
				pr[i].kill();

				//spawn a random marble from the center when it's hit..
				spawnMarble(gameDisc[gamePlayer[0].curDisc]);
				//make the center disc do a bulging animation
				gameDisc[CENTER_DISC].startBulging();

				continue;
			}

			//check for collisions..
			handleProjectileMarbleInteraction(pr[i], gameMarble, numMarbles);
		}
        }

        //handle the title screen stuff
        void titleLogic()
        {
		//handle logo logic
		float maxYOffset = 5.0f;

		logoYOffset += (logoReverse ? -0.1f : 0.1f);
		if(Math.abs(logoYOffset) > maxYOffset)
		{
			logoReverse = !logoReverse;
		}
        }

        //handle the hiscore listing screen stuff
        void hiScoreLogic()
        {
        }

        //handle the game over screen stuff
        void gameOverLogic()
        {
		//have Game Over image fly in from the right and stop
		gameOverPos.add(gameOverVel);
		if(gameOverPos.x <= playW/2-110)
		{
			gameOverVel.zero();
		}
		else    //just spawn some particles along the way...
		{
			for(int i = 0; i < 5; i++)
			{
				float aRad = (float)Math.random()*3.0f+3.0f;
				gameParticleBank.addParticle(new vertex(gameOverPos.x+50, gameOverPos.y+30), new vertex(randNeg()*(float)Math.random()*1.0f+0.25f, randNeg()*(float)Math.random()*1.0f+0.25f), new Color(255, 255, 255, 50+(int)(Math.random()*40)), aRad, aRad, particle.SHAPE_CIRCLE_FILLED, 40, 3);
			}
		}
        }

        //add the player's score/data to the hiscore bank
        void addNewHiScore()
        {
                gameHiScoreBank.addNewScore(playerNameString, gamePlayer[0].score, curLevel);
                gameHiScoreBank.sort(gameHiScoreBank.SORT_BYSCORE);
                saveHiScores();
        }

        //hiscore name entry completed, now let's finish up
        void finishHiScoreEntry()
        {
		System.out.println("High score entry finished. Adding score to list...");
                hiScoreEntryDone = true;
                gotHiScore = false;
                addNewHiScore();
        }

	//initialize Santa-related stuff
	void initializeSanta()
	{
		santaRadius = DEFAULT_SANTA_RADIUS;
		santaSpinSpeed = DEFAULT_SANTA_SPIN_SPEED;
		//santaMode = SANTA_MODE_NORMAL;
		santaMode = SANTA_MODE_DISABLED;
		santaAnimCounter = 0;
		santaAnimRev = false;
		santaSwitchCounter = 0;
		santaSwitchLimit = DEFAULT_SANTA_DIRECTION_SWITCH_LIMIT;
		santaFalling = true;
		santaYOffset = -playH/2-50;
		santaYVel = 4.0f;
		santaYAccel = 0.5f;
	}

        //initialize all the timers we're working with
        void initializeTimers()
        {
                //set the game clock up
                gameClock.reset();

		marbleSpawnTimer = DEFAULT_MARBLE_SPAWN_TIMER;

		//reset the key timers
        }

	//set up the randomized snow..
	void initializeSnow()
	{
		for(int i = 0; i < numSnowFlakes; i++)
		{
			//snow[i] = new snowFlake(new vertex((float)Math.random()*playW, (float)Math.random()*(playH-groundH)), new vertex(-((float)Math.random()*2.0f+0.2f), (float)(Math.random()*2.0f+0.2f)));
			snow[i] = new snowFlake(new vertex(bgSkyPos.x+(float)Math.random()*skyW, bgSkyPos.y+(float)Math.random()*skyH), new vertex(-((float)Math.random()*2.0f+0.2f), (float)(Math.random()*2.0f+0.2f)));
		}
	}

	//initialize the arc
	void initializePlayerArc()
	{
		for(int i = 0; i < 360; i++) arcActive[i] = 0;
	}

        //initialize the players
        void initializePlayers()
        {
		gamePlayer[0] = new player();
		//gamePlayer[0].angle = 3*(float)Math.PI/2;
		updatePlayerCoords(gamePlayer[0]);
		initializePlayerArc();
		hiScoreStatus = 0;

		/*
		int rand, rand2 = (int)(Math.random()*5);
		for(int i = 0; i < numStartingMarbles; i++){
			rand = rand2;
			gamePlayer[0].acquireMarble(rand);
			rand = (int)(Math.random()*5);
			while(rand == rand2) rand = (int)(Math.random()*5);
			rand2 = rand;
			}
		*/
        }

        //initialize the playfield stuff
        void initializePlayfield()
        {
		numDiscs = 0;
		//addDisc(new vertex(playW/2, playH/2), new vertex(), new Color(175, 125, 62), new Color(162, 116, 62), new Color(162, 116, 62), curStartingDiscSize, player.DEFAULT_RADIUS, 0, 0);
		//addDisc(new vertex(playW/2, playH/2), new vertex(), Color.BLACK, new Color(30, 30, 30), Color.BLACK, 15, 0, 0, santaSpinSpeed);
		System.out.println("Adding table disc...");
		addDisc(playFieldPos, new vertex(), new Color(175, 125, 62), new Color(162, 116, 62), new Color(162, 116, 62), curStartingDiscSize, player.DEFAULT_RADIUS, 0, 0);
		System.out.println("Adding Santa disc...");
		//addDisc(playFieldPos, new vertex(), new Color(0, 0, 0, 30), new Color(0, 0, 0, 0), new Color(0, 0, 0, 0), 15, 0, 0, santaSpinSpeed);
		addDisc(playFieldPos, new vertex(), new Color(0, 0, 0, 30), new Color(0, 0, 0, 0), new Color(0, 0, 0, 0), santaRadius-5, 0, (float)Math.PI, santaSpinSpeed);
        }

	//initialize the background-related stuff
	void initializeBackground()
	{
		bgSkyPos = new vertex(bgWindowPos.x+10, 0);

		skyW = (int)windowImage.getWidth()-20;
		skyH = (int)windowImage.getHeight()-5;

		//initialize all the snow variables
		initializeSnow();

		//initialize the fireplace animation stuff
		fireAnimCounter = 0;
		fireAnimSpeed = 4;
		fireAnimRev = false;
	}

	//set the marble color list..
	void initializeMarbleColors()
	{
		marbleColor[0] = new Color(233, 26, 26);
		marbleColor[1] = new Color(8, 214, 108);
		marbleColor[2] = new Color(4, 151, 214);
		marbleColor[3] = new Color(255, 255, 169);
		marbleColor[4] = new Color(167, 78, 255);
		marbleColor[5] = new Color(178, 178, 178);
		marbleColor[6] = new Color(255, 95, 3);
		marbleColor[marble.COLOR_RANDOMIZED] = new Color(255, 255, 255);
		marbleColor[marble.COLOR_IMMOVABLE] = new Color(50, 50, 50);
		marbleColor[marble.COLOR_DEAD] = new Color(60, 20, 20);
	}

        //initialize the item/marble-related stuff
        void initializeMarbles()
        {
		curMarbleRadius = DEFAULT_MARBLE_RADIUS;
		curMarbleSpeed = STARTING_MARBLE_SPEED;

		//deactivate all marble slots that aren't null or inactive
		for(int i = 0; i < numMarbles; i++){
			if(gameMarble[i] == null || gameMarble[i].isInactive()) continue;
			gameMarble[i].deactivate();
			}

		//reset the marble counter to 0 before beginning..
		numMarbles = 0;
        }

        //deinitialize the players
        void deinitializePlayers()
        {
		//kill all the player's marbles..
		gamePlayer[0].killMarbles();
        }

        //deinitialize the items/marbles
        void deinitializeMarbles()
        {
		//first, kill all the active marbles on the playfield
		for(int i = 0; i < numMarbles; i++){
			if(gameMarble[i] == null || gameMarble[i].isInactive()) continue;
			gameMarble[i].kill();
			}
        }

	//move the player's marbles one slot..
	void shiftPlayerMarbles(player pl, int dir)
	{
		if(dir == -1){
			pl.shiftMarblesLeft();
			//check for any matches that may have sprung up due to the shift (would only occur on the end..)
			pl.checkForMarbleMatchesExt(pl.numMarbles-1);
			}
		else{
			pl.shiftMarblesRight();
			//check for any matches that may have sprung up due to the shift (would only occur on the end..)
			pl.checkForMarbleMatchesExt(0);
			}
	}

	//get the first open projectile slot
	int getOpenProjectileSlot()
	{
		for(int i = 0; i < MAX_GAME_PROJECTILES; i++){
			if(gameProjectile[i] == null) return i;
			if(gameProjectile[i].isInactive()) return i;
			}

		return -1;
	}

	//fire a projectile..
	void firePlayerProjectile(player pl)
	{
		int slot = getOpenProjectileSlot();

		if(slot == -1 || slot >= pl.maxProjectiles) return;
		if(slot >= numProjectiles) numProjectiles = slot+1;

		//fire the shot..
		float x = gameDisc[pl.curDisc].pos.x+gameDisc[pl.curDisc].radius*(float)Math.cos(pl.angle);
		float y = gameDisc[pl.curDisc].pos.y+gameDisc[pl.curDisc].radius*(float)Math.sin(pl.angle);
		gameProjectile[slot] = new projectile(new vertex(x, y), pl.angle-(float)Math.PI, pl.projectileSpeed);
	}

	//do the suck animation sequence
	void doPlayerSuck(player pl)
	{
		pl.doSuck();

		//handle the suck line animation
		suckCounter++;
		if(suckCounter > DEFAULT_SUCK_SPACING)
		{
			 suckCounter = 0;
		}

		//slowly increase the suckLength
		if(stillSucking && suckLength <= MAX_SUCK_LENGTH) suckLength += 0.175f;
	}

	//do the chomp animation sequence
	void doPlayerChomp(player pl)
	{
		pl.doChomp();
	}

	//get the first open marble slot
	int getOpenMarbleSlot()
	{
		for(int i = 0; i < MAX_GAME_MARBLES; i++){
			if(gameMarble[i] == null) return i;
			if(gameMarble[i].isInactive()) return i;
			}

		return -1;
	}

	//get random marble color (may change depending on level or other factors)
	int getRandomMarbleColor()
	{
		//different colors/types have different probabilities of showing up..
		double rand = Math.random();
		double div = 0.13;
		if(rand < div) return 0;
		if(rand < div*2) return 1;
		if(rand < div*3) return 2;
		if(rand < div*4) return 3;
		if(rand < div*5) return 4;
		if(rand < div*6) return 5;

		//if(rand < div*6) return 5;

		//make it a bomb if none of the other foods...
		return marble.COLOR_BOMB;
		//return 0;
	}

	//spawn a random marble on this disc..
	void spawnMarble(disc di)
	{
		int slot = getOpenMarbleSlot();

		if(slot == -1) return;
		if(slot >= numMarbles) numMarbles = slot+1;
		//float ang = (float)(Math.random()*Math.PI)*2;
		//float ang = (float)gameDisc[CENTER_DISC].angle;
		float ang = (gameDisc[CENTER_DISC].angleVel >= 0) ? (float)(gameDisc[CENTER_DISC].angle-Math.PI/2) : (float)(gameDisc[CENTER_DISC].angle-Math.PI/2);
		float aRad;
		vertex pPos = new vertex(di.pos.x+(float)Math.cos(ang)*santaRadius, di.pos.y+(float)Math.sin(ang)*santaRadius);
		Color pColor = new Color(255, 255, 255, 128);

		//add some smoke puffs/particles...
		for(int i = 0; i < 6; i++)
		{
			aRad = (float)Math.random()*1.5f+3.0f;
			gameParticleBank.addParticle(pPos, new vertex(randNeg()*(float)Math.random()*1.0f+0.25f, randNeg()*(float)Math.random()*1.0f+0.25f), pColor, aRad, aRad, particle.SHAPE_CIRCLE_FILLED, 40, 3);
		}
		//gameParticleBank.addParticle(di.pos, new vertex(), Color.WHITE, (float)Math.random()*5.0f, (float)Math.random()*5.0f, particle.SHAPE_CIRCLE_FILLED, 40, 3);

		float spdOff = (float)Math.random()*0.25f;  //just some random variance
		gameMarble[slot] = new marble(di.pos, new vertex((curMarbleSpeed+spdOff)*(float)Math.cos(ang), (curMarbleSpeed+spdOff)*(float)Math.sin(ang)), getRandomMarbleColor(), ang, curMarbleRadius);

		//play the release sound
		playShotSound();
	}

	//get the current Santa animation frame
	int getCurSantaAnimFrame()
	{
		return santaAnimCounter/santaAnimSpeed;
	}

	//handle Santa Bot logic..
	void santaLogic()
	{
		//don't animate or anything if Santa is falling, just add to the offset till he hits the table
		if(santaFalling)
		{
			santaYVel += santaYAccel;
			santaYOffset += santaYVel;
			if(santaYOffset >= 0)
			{
				santaFalling = false;
				santaYOffset = 0;
			}
			return;
		}

		//animate Santa
		if(!santaAnimRev)
		{
			santaAnimCounter++;
			if(santaAnimCounter >= santaAnimSpeed*numSantaAnims)
			{
				santaAnimRev = !santaAnimRev;
				santaAnimCounter = santaAnimSpeed*numSantaAnims-1;
			}
		}
		else
		{
			//don't cycle back if we're disabled
			if(santaMode == SANTA_MODE_NORMAL || santaMode == SANTA_MODE_VICTORIOUS)
			{
				santaAnimCounter--;
				if(santaAnimCounter <= 0)
				{
					santaAnimRev = !santaAnimRev;
					santaAnimCounter = 0;
				}
			}
		}

		//handle the stuff when Santa Bot is disabled
		if(santaMode == SANTA_MODE_DISABLED)
		{
			santaDisabledTimer++;
			if(santaDisabledTimer >= DEFAULT_SANTA_DISABLED_TIME)
			{
				//reset the animation stuff
				santaAnimCounter = 0;
				santaAnimRev = false;

				//reset Santa to normal...
				santaMode = SANTA_MODE_NORMAL;
				santaDisabledTimer = 0;
			}
		}
	}

	//handle disc logic stuff..
	void discLogic(disc di[], int num)
	{
		for(int i = 0; i < num; i++)
		{
			if(di[i] == null || di[i].isInactive()) continue;
			//di[i].move(santaMode != SANTA_MODE_NORMAL);
			di[i].move();
			if(santaMode == SANTA_MODE_NORMAL) di[i].spin();
			if(di[i].isBulging()) di[i].bulge(santaMode == SANTA_MODE_VICTORIOUS);
		}
	}

	//handle falling snow logic
	void snowLogic(snowFlake sf[], int num)
	{
		for(int s = 0; s < num; s++)
		{
			if(sf[s] == null) continue;

			sf[s].pos.add(sf[s].vel);
			//wrap the flakes if need be..
			if(sf[s].pos.x < bgSkyPos.x-sf[s].radius) sf[s].pos.x = bgSkyPos.x+skyW+sf[s].radius;
			if(sf[s].pos.y >= skyH+sf[s].radius)
			{
				sf[s].pos.y = -sf[s].radius;
			}
		}
	}

	//get current fire animation frame
	int getFireAnimFrame()
	{
		return fireAnimCounter/fireAnimSpeed;
	}

	//handle all the background logic
	void backgroundLogic()
	{
		snowLogic(snow, numSnowFlakes);

		//do the fire animation stuff
		if(!fireAnimRev)
		{
			fireAnimCounter++;
			if(fireAnimCounter >= fireAnimSpeed*MAX_FIREPLACE_ANIMS)
			{
				fireAnimCounter = fireAnimSpeed*MAX_FIREPLACE_ANIMS-1;
				fireAnimRev = !fireAnimRev;
			}
		}
		else
		{
			fireAnimCounter--;
			if(fireAnimCounter <= 0)
			{
				fireAnimCounter = 0;
				fireAnimRev = !fireAnimRev;
			}
		}
	}

        //particle logic..
        void particleLogic(particleBank pb)
        {
                for(int i = 0; i < pb.numParticles; i++)
		{
                        if(pb.bParticle[i] != null && !pb.bParticle[i].isInactive())
			{
                                pb.bParticle[i].logic();
			}
		}
        }

	//restart the marble spawn timer..
	void resetMarbleSpawnTimer()
	{
	        marbleSpawnTimer = (int)(Math.random()*(DEFAULT_MARBLE_SPAWN_TIMER-curLevel*25)+MIN_MARBLE_SPAWN_TIMER);
		if(marbleSpawnTimer <= MIN_MARBLE_SPAWN_TIMER) marbleSpawnTimer = MIN_MARBLE_SPAWN_TIMER;
	}

	//see if we're ready for a level up..
	void checkForPlayerLevelUp(player pl)
	{
		if(pl.marbleScore >= nextLevelUp)
		{
			doLevelUp();
		}
	}

	//do the level up sequence..
	void doLevelUp()
	{
		//increment the level counter..
		if(curLevel < maxLevels){
			curLevel++;
			//increment the level up tally..
			nextLevelUp += (MARBLES_PER_LEVELUP + 4*(curLevel/2));

			//add a "level up!" message..
			gameParticleBank.addParticle(new vertex(101, 101), new vertex(0, -1), "Level up!", gameFont, Color.BLACK, 0, 0, particle.SHAPE_TEXT, 35);
			gameParticleBank.addParticle(new vertex(100, 100), new vertex(0, -1), "Level up!", gameFont, Color.WHITE, 0, 0, particle.SHAPE_TEXT, 35);
			}
	}

        //handle the game timer/clock logic
        void timerLogic()
        {
                //update the game clock
                gameClock.update();

		//don't bother with the rest unless Santa is in normal mode
		if(santaMode != SANTA_MODE_NORMAL) return;

                //handle item spawn timer
                if(--marbleSpawnTimer <= 0)
		{
                        spawnMarble(gameDisc[gamePlayer[0].curDisc]);
                        resetMarbleSpawnTimer();

			//make the center disc do a bulging animation
			gameDisc[CENTER_DISC].startBulging();

			//handle the Santa direction switches...
			//don't bother if there is no current limit yet
			if(santaSwitchLimit < 0) return;

			santaSwitchCounter++;
			if(santaSwitchCounter >= santaSwitchLimit)   //if we've released enough marbles...
			{
				//reset the switch counter
				santaSwitchCounter = 0;
				//reset the switch limit to a different number
				int lim = (int)Math.random()*DEFAULT_SANTA_DIRECTION_SWITCH_LIMIT-curLevel*2+2;
				santaSwitchLimit = (lim <= 0 ? 2 : lim);
				//send the disc spinning in the other direction
				gameDisc[SANTA_DISC].angleVel *= -1;
			}
		}
        }

	//update the player's cartesian coords so we can get an absolute position..
	void updatePlayerCoords(player pl)
	{
		float x = gameDisc[pl.curDisc].pos.x+gameDisc[pl.curDisc].radius*(float)Math.cos(pl.angle);
		float y = gameDisc[pl.curDisc].pos.y+gameDisc[pl.curDisc].radius*(float)Math.sin(pl.angle);
		pl.pos.set(x, y);
	}

	//handle the level-up logic
	void levelUpLogic(player pl)
	{
		System.out.println("Level up!");

		//play the level-up sound
		playLevelUpSound();

		//start FB's arc clearing
		pl.startArcClearing();

		//go to next level
		curLevel++;

		//clear everything on board and give points and multipliers
		clearMarbles();

		//toggle levelUp off
		levelUp = false;

		//increase Santa's spin...
		santaSpinSpeed *= 1.15f;
		if(santaSpinSpeed > MAX_SANTA_SPIN_SPEED) santaSpinSpeed = MAX_SANTA_SPIN_SPEED;
		gameDisc[CENTER_DISC].setSpinSpeed(santaSpinSpeed);

		//add "level up" message
		gameParticleBank.addParticle(new vertex(gameDisc[SANTA_DISC].pos.x-santaRadius*2, gameDisc[SANTA_DISC].pos.y-santaRadius*2), new vertex(0, -0.5f), "Level up!", gameFontBig, Color.WHITE, 1, 1, particle.SHAPE_TEXT, 50);

		//increase new marble speed
		curMarbleSpeed += 0.1f;

		/*
		//increment the level counter..
		if(curLevel < maxLevels){
			curLevel++;
			//increment the level up tally..
			nextLevelUp += (MARBLES_PER_LEVELUP + 4*(curLevel/2));

			//add a "level up!" message..
			gameParticleBank.addParticle(new vertex(21, 101), new vertex(0, -1), "Level up!", gameFont, Color.BLACK, 0, 0, particle.SHAPE_TEXT, 35);
			gameParticleBank.addParticle(new vertex(20, 100), new vertex(0, -1), "Level up!", gameFont, Color.WHITE, 0, 0, particle.SHAPE_TEXT, 35);
			}
		*/
	}

	//prepare to transition between gameplay state and game-over state
	public void beginGameOverSequence()
	{
		gameState = GAMESTATE_GAMEOVER;
	 	clearMarbles();

		//set Santa Bot to victorious so he can gloat
		santaMode = SANTA_MODE_VICTORIOUS;

		//stop spinning Santa's disc
		gameDisc[SANTA_DISC].stopSpinning();

		//start bulging Santa to mimic laughter
		gameDisc[SANTA_DISC].startBulging();

		//add "game over" message
		//gameParticleBank.addParticle(new vertex(gameDisc[SANTA_DISC].pos.x-75, gameDisc[SANTA_DISC].pos.y), new vertex(0, -0.5f), "Game Over", gameFontBig, Color.WHITE, 1, 1, particle.SHAPE_TEXT, -1);

		//check if we've got a high score
		checkForHiScores();

		if(musicOn)
		{
			//stop the music if it's playing...
			stopMusic();

			//start the game-over music
			playMusic(gameOverSong);
		}

		//start playing Santa's laughter..
		playLaughSound();
	}

	//just initialize miscellaneous stuff that needs to be initialized...
	void initializeMisc()
	{
		gameOverPos = new vertex(playW, playH/2-250);
		gameOverVel = new vertex(-30, 0);
	}

        //main logic stuff
        void updateApp()
        {
                //get the elapsed time slice
                //long dt = gameAverageTimer.deltaT(System.currentTimeMillis());

                //convert to a float fraction of 1 sec
                //float ft = (float)dt*0.001f;

                switch(gameState){
			case GAMESTATE_TITLE_INITIALIZE:
				initializeBackground();
                                initializePlayfield();

				gameState = GAMESTATE_TITLE;

				break;
                        case GAMESTATE_TITLE:
                                titleLogic();
				backgroundLogic();

                                break;
                        case GAMESTATE_INITIALIZE:
                                //initializePlayfield();
                                initializeTimers();
				initializeMarbleColors();
                                initializePlayers();
                                initializeMarbles();
				initializeSanta();
				initializeMisc();
				nextLevelUp = MARBLES_PER_LEVELUP;
				curLevel = 0;
				mouseDepressed = false;
				keyDepressed = false;
                                gotHiScore = false;
                                hiScoreEntryDone = false;
                                System.out.println("game initialized.. starting level..");

				//play a little jingle..
				//playLevelInSound();

				//start the in-game music
				if(musicOn)
				{
					if(gameSong == null) System.out.println("Module not loaded..");
					System.out.println("Starting song..");
					playMusic(gameSong);
				}

                                gameState = GAMESTATE_READY;

                                break;
                        case GAMESTATE_GAMEOVER_BEGIN:
                                deinitializePlayers();
                                deinitializeMarbles();
                                if(isOnline) checkForHiScores();

                                gameState = GAMESTATE_GAMEOVER;

                                break;
                        case GAMESTATE_GAMEOVER:
                                gameOverLogic();
                                playerLogicAll(gamePlayer, numPlayers);
				santaLogic();
				discLogic(gameDisc, numDiscs);
                               	marbleLogic(gameMarble, numMarbles);
				particleLogic(gameParticleBank);
				backgroundLogic();

                                break;
                        default:
				if(!paused)
				{
	                                playerLogicAll(gamePlayer, numPlayers);
					santaLogic();
					discLogic(gameDisc, numDiscs);
                                	marbleLogic(gameMarble, numMarbles);
					//projectileLogic(gameProjectile, numProjectiles);
					particleLogic(gameParticleBank);
					backgroundLogic();
        	                        timerLogic();

					//if it's time to level-up, do the appropriate logic
					if(levelUp)
					{
						levelUpLogic(gamePlayer[0]);
					}
				}

                                break;
                        }
        }

	//play any old audio clip
	public void playClip(Clip clip)
	{
		if(clip == null) return;
		clip.setFramePosition(0);               //reset to frame 0
		clip.loop(0);
	}

	//play the maniacal laughter
	public void playLaughSound()
	{
		if(isOnline && soundOn && soundLaugh != null) soundLaugh.loop();
		else if(!isOnline && soundOn && soundLaughC != null){ soundLaughC.setFramePosition(0); soundLaughC.loop(Clip.LOOP_CONTINUOUSLY); }
		//else if(!isOnline && soundOn && soundLaughX != null) AudioPlayer.player.start(soundLaughX);
		else System.out.println("Sound output error...");
	}

	//stop the laughter..
	public void stopLaughSound()
	{
		if(isOnline && soundOn && soundLaugh != null) soundLaugh.stop();
		else if(!isOnline && soundOn && soundLaughC != null) soundLaughC.stop();
		//else if(!isOnline && soundOn && soundLaughX != null) AudioPlayer.player.stop(soundLaughX);
		else System.out.println("Sound output error...");
	}

        //play the chomping sound
        public void playChompSound()
        {
                if(isOnline && soundOn && soundChomp != null) soundChomp.play();
				else if(!isOnline && soundOn) playClip(soundChompC);
				else System.out.println("Sound output error:");
        }
        //play the explosion
        public void playExplosionSound()
        {
                if(isOnline && soundOn && soundExplosion != null) soundExplosion.play();
				else if(!isOnline && soundOn) playClip(soundExplosionC);
				//else if(!isOnline && soundOn && soundExplosionX != null) AudioPlayer.player.start(soundExplosionX);
				else System.out.println("Sound output error...");
        }
        //play the level up sound
        public void playLevelUpSound()
        {
                if(isOnline && soundOn && soundLevelUp != null) soundLevelUp.play();
				else if(!isOnline && soundOn) playClip(soundLevelUpC);
				//else if(!isOnline && soundOn && soundLevelUpX != null) AudioPlayer.player.start(soundLevelUpX);
				else System.out.println("Sound output error...");
        }
        //play the level intro sound
        public void playLevelInSound()
        {
                if(isOnline && soundOn && soundLevelIn != null) soundLevelIn.play();
        }
        //play the smash sound
        public void playSmashSound()
        {
                if(isOnline && soundOn && soundSmash != null) soundSmash.play();
				else if(!isOnline && soundOn) playClip(soundSmashC);
				//else if(!isOnline && soundOn && soundSmashX != null) AudioPlayer.player.start(soundSmashX);
				else System.out.println("Sound output error...");
        }
	//play the bouncing sound
	public void playBounceSound()
	{
		if(isOnline && soundOn && soundBounce != null) soundBounce.play();
		else if(!isOnline && soundOn) playClip(soundBounceC);
		else System.out.println("Sound output error...");
	}
	//play the Santa shot sound
	public void playShotSound()
	{
		if(isOnline && soundOn && soundShot != null) soundShot.play();
		else if(!isOnline && soundOn) playClip(soundShotC);
		else System.out.println("Sound output error...");
	}
	//play the hi-score sound
	public void playHiScoreSound()
	{
		if(isOnline && soundOn && soundHi != null) soundHi.play();
		else if(!isOnline && soundOn) playClip(soundHiC);
		else System.out.println("Sound output error...");
	}

	//gives the quadrant # of this angle.. (1-4)
	public int getQuadrant(float ang)
	{
		if(ang >= 0 && ang < (float)Math.PI/2) return 1;
		if(ang >= (float)Math.PI/2 && ang < (float)Math.PI) return 2;
		if(ang >= (float)Math.PI && ang < 3*(float)Math.PI/2) return 3;
		return 4;
	}

	//draw this string with a shadow beneath it..
	public void drawStringShadowed(Graphics g, String str, Color col, int x, int y, int xoff, int yoff)
	{
		g.setColor(Color.BLACK);
		g.drawString(str, x+xoff, y+yoff);
		g.setColor(col);
		g.drawString(str, x, y);
	}

	//draws this string centered at this point..
	public void drawStringCentered(Graphics g, String str, int x, int y)
	{
		FontMetrics fontM = g.getFontMetrics();
		int txtW = fontM.stringWidth(str);
		int txtH = fontM.getHeight();
		g.drawString(str, x-txtW/2, y-txtH/2);
	}

	//draws this string aligned to the left of this point..
	public void drawStringRightAligned(Graphics g, String str, int x, int y)
	{
		FontMetrics fontM = g.getFontMetrics();
		int txtW = fontM.stringWidth(str);
		g.drawString(str, x-txtW, y);
	}

	//draws a filled circle centered at these coords
	public void drawFilledCircleCentered(Graphics g, int x, int y, int radius)
	{
		g.fillOval(x-radius, y-radius, radius*2, radius*2);
	}
	//draws a circle outline centered at these coords
	public void drawCircleCentered(Graphics g, int x, int y, int radius)
	{
		g.drawOval(x-radius, y-radius, radius*2, radius*2);
	}

	//draws a filled rect centered at these coords
	public void drawFilledRectCentered(Graphics g, int x, int y, int hRad, int vRad)
	{
		g.fillRect(x-hRad, y-vRad, hRad*2, vRad*2);
	}
	//draws a filled rect centered at these coords
	public void drawRectCentered(Graphics g, int x, int y, int hRad, int vRad)
	{
		g.drawRect(x-hRad, y-vRad, hRad*2, vRad*2);
	}

	//returns a random negativity.. (50% chance)
	int randNeg(){ return (Math.random() < 0.5 ? -1 : 1); }

        //use this to load a buffered image
        //by first loading an Image,
        //then converting it to a BufferedImage
        BufferedImage loadBufferedImage(String filename)
        {
                Image tempImage = loadImageSync(filename);
                return toBufferedImage(tempImage);
        }

        //create a fresh buffered image
        public static BufferedImage createBufferedImage(int w, int h)
        {
                return new BufferedImage(w, h, BufferedImage.TYPE_INT_ARGB);
        }

        // This method returns a buffered image with the contents of an image
        public static BufferedImage toBufferedImage(Image image)
        {
                if(image instanceof BufferedImage) {
                        return (BufferedImage)image;
                        }

                // This code ensures that all the pixels in the image are loaded
                image = new ImageIcon(image).getImage();

                // Determine if the image has transparent pixels; for this method's
                // implementation, see e661 Determining If an Image Has Transparent Pixels
                boolean hasAlpha = true;

                // Create a buffered image with a format that's compatible with the screen
                BufferedImage bimage = null;
                GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
                try {
                        // Determine the type of transparency of the new buffered image
                        int transparency = Transparency.OPAQUE;
                        if (hasAlpha) {
                                transparency = Transparency.TRANSLUCENT;
                                }
                        // Create the buffered image
                        GraphicsDevice gs = ge.getDefaultScreenDevice();
                        GraphicsConfiguration gc = gs.getDefaultConfiguration();
                        bimage = gc.createCompatibleImage(
                                image.getWidth(null), image.getHeight(null), transparency);
                        } catch (HeadlessException e) { }
                        // The system does not have a screen

                if (bimage == null) {
                        // Create a buffered image using the default color model
                        int type = BufferedImage.TYPE_INT_RGB;
                        if (hasAlpha) {
                                type = BufferedImage.TYPE_INT_ARGB;
                                }
                        bimage = new BufferedImage(image.getWidth(null), image.getHeight(null), type);
                        }

                // Copy image to buffered image
                Graphics g = bimage.createGraphics();

                // Paint the image onto the buffered image
                g.drawImage(image, 0, 0, null);
                g.dispose();

                return bimage;
        }

        //  loadImageSync() from http://www.spacejack.org/games/dbufanim/
        //  credits to Mike Linkovich
        //
        //  Simple method to load & wait for image synchronously
        //  rather than deal with threading.  I find this is
        //  usually more useful, however if you needed to perform
        //  other tasks while loading, then you should take advantage
        //  of Java's asynchronous getImage loads.
        //
        Image loadImageSync(String imgFile)
        {

			MediaTracker mt = null;
			Image img = null;

			//  Start loading the graphics...
			//
			if(!isApplication)
			{
				System.out.println("We're online...");
				img = getImage(getCodeBase(), imgFile);
			}
			else
			{
				URL imgURL = getClass().getResource(imgFile);
				Toolkit tk = Toolkit.getDefaultToolkit();
				System.out.println("We're in the application...");
				img = tk.getImage(imgURL);
				//img = Toolkit.getDefaultToolkit().getImage(imgFile);
				//try{ img = getImage(new File(imgFile).toURI().toURL()); } catch(Exception E){}
			}

			if(img == null) System.out.println("Image is null..");

			System.out.println("Loaded file '" + imgFile + "' with dimensions " + img.getWidth(this) + "x" + img.getHeight(this));

			mt = new MediaTracker(this);
			mt.addImage( img, 0 );

			//  Wait here 'till it's done
			//
			try
			{
	  			mt.waitForAll();
			}
			catch(Exception e)
			{
				img = null;
			};

			if(img == null || img.getWidth(this) < 0) System.err.println( "Failed to load image: '" + imgFile + "'" );

			return img;
/*
                MediaTracker mt;
                Image img;

                //  Start loading the graphics...
                //
                img = getImage(getCodeBase(), imgFile);
                mt = new MediaTracker(this);
                mt.addImage( img, 0 );

                //  Wait here 'till it's done
                //
                try
                {
                        mt.waitForAll();
                } catch(Exception e) { img = null; };

                if( img == null || img.getWidth(this) < 0 )
                System.err.println( "Failed to load image: '" + imgFile + "'" );

                return img;
*/
		}

        //load a font from a remote server
        public Font loadRemoteFont(String filename, int size, boolean bold)
        {
                URL url = null;
                try{
                        System.out.println("opening filename: " + filename);
                        url = new URL("http", "www.t3-i.com", filename);
                }catch(MalformedURLException e){ System.out.println("malformed URL.."); return null; }

                InputStream iStream = null;
                try{
                        System.out.println("opening inputstream at " + url.toString());
                        iStream = url.openStream();
                        }catch(IOException e){ System.out.println("error: " + e.getMessage()); return null; }

                try{
                        System.out.println("filesize: " + iStream.available() + " bytes");
                        }catch(Exception e){ }

                Font tempFont = null;

                try{
                        try{
                                tempFont = Font.createFont(Font.TRUETYPE_FONT, iStream);
                                System.out.println("font loaded: " + tempFont.toString());
                                }catch(IOException e){ System.out.println("error: " + e.getMessage()); return null; }
                        }catch(FontFormatException e){ System.out.println("error: " + e.getMessage()); return null; }

                if(tempFont == null) System.out.println("font loading failed..");
                return tempFont.deriveFont(bold ? Font.BOLD : Font.PLAIN, size);
        }

        //method for giving a string with a set number of "0" spaces (long)
        public String longNumberString(long number, int length)
        {
                String temp_str = new String();
                int power = 0;
                long temp_num = number;

                while(temp_num > 0){         //divide by 10 till number is 0
                        temp_num /= 10;
                        power++;             //count the powers of ten
                        }
                length -= power;
                while(length > 0){
                        temp_str += "0";     //start with # of 0's equal to power difference
                        length--;
                        }
                if(number != 0) temp_str += Long.toString(number);  //add original # to 0'ed string

                return temp_str;
          }

        //method for giving a string with a set number of "0" spaces (int)
        public String intNumberString(int number, int length)
        {
                String temp_str = new String();
                int power = 0, temp_num = number;

                while(temp_num > 0){         //divide by 10 till number is 0
                        temp_num /= 10;
                        power++;             //count the powers of ten
                        }
                length -= power;
                while(length > 0){
                        temp_str += "0";     //start with # of 0's equal to power difference
                        length--;
                        }
                if(number != 0) temp_str += Integer.toString(number);  //add original # to 0'ed string

                return temp_str;
        }

        //check if we got any hiscores this game
        public void checkForHiScores()
        {
                //load the remote hiscore list first so we get the latest scores..
                if(isOnline) loadHiScores();
                gotHiScore = gameHiScoreBank.isHiScoreScore(gamePlayer[0].score);
                if(gotHiScore)
		{
			System.out.println("We got a high score!");
			hiScoreEntryDone = false;
		}
		else hiScoreEntryDone = true;
        }

        //save the current hiscores to file
        public void saveHiScores()
        {
                System.out.println("Saving scores..");
                if(isOnline) gameHiScoreBank.saveFile("/cgi/fbfwrite.pl");
				else gameHiScoreBank.saveGenericFile("fbxfeast.hi");
        }

        //load hiscores from file
        public void loadHiScores()
        {
                System.out.println("Loading scores..");
				//load remote scores..
                if(isOnline) gameHiScoreBank.loadFile("/fbxfeast/hiscore.txt");
				//load local scores..
				else gameHiScoreBank.loadGenericFile("fbxfeast.hi");
        }

	//keeps angle between 0 and 2pi (just a wrapper from the vertex function)
	public static double angleMod(double angle)
	{
		return vertex.angleMod(angle);
	}

	//keeps angle between 0 and 360
	public static int angleModDegrees(int angle)
	{
		if(angle < 0) return angle+360;
		else if(angle >= 360) return angle-360;

		return angle;
	}

	//check to see if angle falls within these angle boundaries
	public static boolean angleIsBetween(double a, double a1, double a2)
	{
		//angle a will always be between 0 and 2pi
		//double aa = a + Math.PI*2;

		double aa1, aa2;
		aa1 = a1 + (a1 >= 0 ? 0 : Math.PI*2);
		aa2 = a2 + (a2 >= 0 ? 0 : Math.PI*2);

		return a >= aa1 && a <= aa2;
	}

	//checks to see if the angle is within this arc (just a dumb array state check, but hey, it works)
	public static boolean angleIsWithinArc(double a, double a0, double al)
	{
		return arcActive[(int)Math.toDegrees(a)] != 0;
	}

	//tells whether this angle falls within the suck bounds
	boolean isWithinSuckBounds(float ang)
	{
		return arcActive[Math.abs((int)Math.toDegrees(ang))] == 2;
	}

	public static int angleIsWithinArcDebug(double a, double a0, double al)
	{
		//if leftmost angle is < 0, do a0 + arclength
		if(a0 < 0)
		{
			//if(a >= angleMod(a0) && a <= a0+al) return 1;
			//if(a >= a0 && a <= a0+al) return 1;
			if(a >= angleMod(a0) && a <= angleMod(a0)+al) return 1;
		}
		else
		{
			if(a0+al > Math.PI*2)
			{
				if(a >= a0 && a <= angleMod(a0)+al) return 2;
			}
		}

		if(a >= angleMod(a0) && a <= angleMod(a0+al)) return 2;
		return 0;
	}

	public URL filenameToURL(String filename)
	{
		URL fileURL;
		try
		{
			//fileURL = new URL(getCodeBase(), filename);
			fileURL = new File(filename).toURI().toURL();
		}
		catch(Exception e)
		{
			System.out.println("Error getting URL..");
			return null;
		}
		return fileURL;
	}

	//load a music file
	public Module loadMusic(String filename)
	{
		URL fileURL = this.getClass().getClassLoader().getResource(filename);

		System.out.println("Loading module file " + filename + " URL(" + fileURL.toString() + ")..");
		return new Module(fileURL);
		//return new Module(filenameToURL(filename));
	}

	//play this music file
	public void playMusic(String filename)
	{
		if(music_player != null)
		{
			stopMusic();
		}
		System.out.println("Initializing music player for file " + filenameToURL(filename));
		music_player = new musicPlayer(filenameToURL(filename));
		music_player.play();
	}

	public void playMusic(Module module)
	{
		if(music_player != null)
		{
			stopMusic();
		}
		music_player = new musicPlayer(module);
		music_player.play();
	}

	public void stopMusic()
	{
		if(music_player != null) music_player.stop();
		else System.out.println("music_player is null, for some reason..");
		//music_player = null;
	}


	//start the application (graphics set-up, etc)
	public void beginApplication(Frame f, GraphicsDevice device)
	{
		      boolean isFullscreen;
		      isApplication = true;
		      if(!useFullscreen)
		      {
			         f.setSize(APP_W+10, APP_H+30);
		      }
		      else
		      {
		           isFullscreen = device.isFullScreenSupported();
			       System.out.println("full screen support: " + isFullscreen);
        		   f.setUndecorated(isFullscreen);
        		   f.setResizable(!isFullscreen);
        		   if(isFullscreen)
			         {
            			  // Full-screen mode
            			  device.setFullScreenWindow(f);
            			  f.validate();
			         }
		           else
			         {
            			  // Windowed mode
            			  //f.pack();
			              f.setSize(APP_W, APP_H);
            			  f.setVisible(true);
        		   }
		      }
	}

	//main loop (when used as application..)
	public static void main(String args[])
	{
		      final fbx2k13 applet = new fbx2k13();
		      Frame f = new Frame(versionString);
		      GraphicsEnvironment env = GraphicsEnvironment.getLocalGraphicsEnvironment();
		      GraphicsDevice device = env.getDefaultScreenDevice();

		      f.addWindowListener(new java.awt.event.WindowAdapter()
		      {
			         public void windowClosing(java.awt.event.WindowEvent e)
			         {
				             applet.stop();
				             applet.destroy();
				             System.exit(0);
			         };
		      });

		      f.add(applet, BorderLayout.CENTER);
		      applet.beginApplication(f, device);
		      f.show();
		      applet.init();    //initialize the applet
		      applet.start();
	}
}
