import java.io.*;
import java.net.*;

class hiScoreBank
{
        final static int MAX_SCORES = 10;
        final static int SORT_BYSCORE = 0;

        hiScore[] score = new hiScore[MAX_SCORES];
        int numScores = 0;

        //constructors
        public hiScoreBank()
        {
		numScores = 0;
        }

	//initialize a dummy scoreboard with this as the top score
	public void initializeDummyScores(long bestScore)
	{
		long sc = bestScore;
		long sd = bestScore/10;
		numScores = 0;
		addNewScore("St. Nick", bestScore, 3);
		addNewScore("Food Boy", bestScore-sd, 3);
		addNewScore("Ludwig Van", bestScore-sd*2, 3);
		addNewScore("JS Bach", bestScore-sd*3, 3);
		addNewScore("Frederick", bestScore-sd*4, 3);
		addNewScore("Reginald", bestScore-sd*5, 3);
		addNewScore("John Boy", bestScore-sd*6, 3);
		addNewScore("Grimace", bestScore-sd*7, 3);
		addNewScore("Sally", bestScore-sd*8, 3);
		addNewScore("Dude", bestScore-sd*9, 3);
		for(int i = 0; i < numScores; i++) score[i].isCurrent = false;
	}

        //sort the scores.. (use heap sort..) sortflag tells what to sort by (returns the slot of the latest score (which is the one at the bottom to start...)
        public void sort(int sortFlag)
        {
                //no need to sort if < 2 scores in the list..
                if(numScores == 1 || numScores == 0) return;
                else if(numScores < 3){
                        switch(sortFlag){
                                case SORT_BYSCORE:
                                        if(score[0].score < score[1].score){
                                                hiScore tempHi = score[0];
                                                score[0] = score[1];
                                                score[1] = tempHi;
                                                }
                                        break;
                                default:
                                        break;
                                }
                        }
                else{
                        switch(sortFlag){
                                case SORT_BYSCORE:
                                        for(int i = 1; i < numScores; i++){
                                                hiScore tempHi = score[i];
                                                int j = i;
                                                while(j > 0 && score[j-1].score < tempHi.score){
                                                        score[j] = score[j-1];
                                                        j--;
                                                        }
                                                score[j] = tempHi;
                                                }
                                        break;
                                default:
                                        break;
                                }
                        }
        }

        //add a new score to the score list
        public void addNewScore(String nm, long sc, int lv)
        {
                //make sure we don't go out of bounds here..
                if(numScores >= MAX_SCORES) numScores--;

                score[numScores] = new hiScore();
                score[numScores].name = nm;
                score[numScores].score = sc;
                score[numScores].level = lv;
		score[numScores].isCurrent = true;

		//set all the previous scores to not be the current one...
		if(numScores > 0)
		{
			for(int i = 0; i < numScores; i++) score[i].isCurrent = false;
		}
                numScores++;
        }

        //add a new score to the score list (from the file)
        public void addNewScoreFromFile(String nm, long sc, int lv)
        {
                //make sure we don't go out of bounds here..
                if(numScores >= MAX_SCORES) numScores--;

                score[numScores] = new hiScore();
                score[numScores].name = nm;
                score[numScores].score = sc;
                score[numScores].level = lv;
				score[numScores].isCurrent = false;

				//set all the previous scores to not be the current one...
				if(numScores > 0)
				{
					for(int i = 0; i < numScores; i++) score[i].isCurrent = false;
				}
            	numScores++;
        }

        //check to see if the data passed qualifies for a spot in the hiscore table
        public boolean isHiScoreScore(long sc)
        {
                if(numScores < MAX_SCORES-1) return true;
                for(int i = numScores-1; i >= 0; i--){
                        if(sc > score[i].score) return true;
                        }
                return false;
        }

        //load the scores from a file
        public void loadFile(String filename)
        {
                remoteStream tempStream = new remoteStream("www.t3-i.com", "");
                int numDataVars = 3;
                String[] tempStr = new String[MAX_SCORES*numDataVars];

                System.out.println("loading data from remote server..");
                tempStr = tempStream.loadData(filename, MAX_SCORES*numDataVars);
                int count = 0;
                String[] tempStr2 = new String[numDataVars];
                numScores = 0;

                //keep going until there aren't any more words found in the string array
                while(count < MAX_SCORES && tempStr[count*numDataVars] != null){
                        for(int i = 0; i < numDataVars; i++){
                                tempStr2[i] = tempStr[count*numDataVars+i];
                                System.out.println(tempStr2[i]);
                                }
                        addNewScoreFromFile(tempStr2[0], Long.parseLong(tempStr2[1]), Integer.parseInt(tempStr2[2]));
                        count++;
                        }
        }

		//load the dictionary from any plain text file
		public void loadGenericFile(String filename)
		{
				int numDataVars = 3;
				//String[] tempStr = new String[MAX_SCORES*numDataVars];

				System.out.println("loading data from hiscore file " + filename + "...");
				//tempStr = tempStream.loadData(filename, MAX_SCORES*numDataVars);
				int count = 0;
				String[] tempStr2 = new String[MAX_SCORES*numDataVars];
				numScores = 0;
				boolean localFileExists = true;     //use this to see if we've got a hiscore.txt saved already

				try
				{
					URL fileURL = null;
					BufferedReader bufferedReader = null;
					FileReader fileReader = null;

					// FileReader reads text files in the default encoding.
					try{ fileReader = new FileReader(filename); }
					catch(Exception E)   //if the file can't be read here, that means it doesn't exist yet locally..
					{
						localFileExists = false;
					}
					//FileReader fileReader = new FileReader(fileURL);

					if(localFileExists)
					{
						System.out.println("Hiscore file exists, so loading file for data extraction..");
						bufferedReader = new BufferedReader(fileReader);
						//bufferedReader = new BufferedReader(new InputStreamReader(getClass().getResourceAsStream(filename)));
					}
					else
					{
						System.out.println("Hiscore file doesn't exist, so setting initial hiscore board...");
						initializeDummyScores(15000);
						//InputStream in = getClass().getResourceAsStream(filename);
						//bufferedReader = new BufferedReader(new InputStreamReader(in));
						return;
					}

//					try{ fileURL = getClass().getClassLoader().getResource(filename); } catch(Exception E){ System.out.println("File " + filename + " not found."); }

					// Always wrap FileReader in BufferedReader.
					//BufferedReader bufferedReader = new BufferedReader(fileReader);

					tempStr2[0] = "NULL";

					if(tempStr2[0] == null) System.out.println("score 0 is null...");

					//keep going until there aren't any more words found in the string array
					while(count < MAX_SCORES) // && tempStr2[count*numDataVars] != null)
					{
						for(int i = 0; i < numDataVars; i++)
						{
								tempStr2[i] = bufferedReader.readLine();
								//break out if we reach an empty line or EOF
								if(tempStr2[i] == null) break;
								System.out.println("Line #" + count*numDataVars+i + ": " + tempStr2[i]);
								//tempStr2[i] = tempStr[count*numDataVars+i];
								//System.out.println(tempStr2[i]);
						}
						addNewScoreFromFile(tempStr2[0], Long.parseLong(tempStr2[1]), Integer.parseInt(tempStr2[2]));
						count++;
				}

				// Always close files.
		  		bufferedReader.close();

				//numWords = 0;
/*
				try{
					// FileReader reads text files in the default encoding.
					FileReader fileReader = new FileReader(filename);

					// Always wrap FileReader in BufferedReader.
					BufferedReader bufferedReader = new BufferedReader(fileReader);

					String line = null;
					while((line = bufferedReader.readLine()) != null)
		  			{
		  					//addWord(line);
		  			}
*/
		}
		catch(FileNotFoundException ex)
		{
			System.out.println("Unable to open file '" + filename + "'");
			initializeDummyScores(15000);
		}
		catch(IOException ex)
	  	{
			System.out.println("Error reading file '" + filename + "'");
			initializeDummyScores(15000);
	  	}
}

		public void saveGenericFile(String wp)
		{
				int numDataVars = 3;
				String tempStr = "";
				PrintWriter out = null;
				for(int i = 0; i < numScores; i++)
				{
						tempStr += score[i].name;
						tempStr += "\n";
						tempStr += score[i].score;
						tempStr += "\n";
						tempStr += score[i].level;
						tempStr += "\n";
				}
				System.out.println("Saving score data to file...");
				try{ out = new PrintWriter(wp); } catch(Exception E){ System.out.println("Error creating PrintWriter."); }
				out.print(tempStr);
				out.close();
		}

        //save the scores to a file
        public void saveFile(String wp)
        {
                remoteStream tempStream = new remoteStream("www.t3-i.com", wp);

                int numDataVars = 3;
                String tempStr = "";
                for(int i = 0; i < numScores; i++){
                        tempStr += score[i].name;
                        tempStr += "\n";
                        tempStr += score[i].score;
                        tempStr += "\n";
                        tempStr += score[i].level;
                        tempStr += "\n";
                        }
                System.out.println("Sending data to remote server..");
                try{
                        tempStream.sendData(tempStr);
                        }
                catch(Exception e){
                        System.out.println("an exception has occured:" + e.getMessage());
                        }
        }
}
