import java.applet.*;
import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Font;
import java.awt.KeyboardFocusManager;
import java.awt.Toolkit;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.dnd.DropTarget;
import java.awt.dnd.DropTargetAdapter;
import java.awt.dnd.DropTargetDropEvent;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.io.*;
import java.net.*;
import java.util.List;
import java.util.Vector;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.SourceDataLine;
import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.SwingUtilities;
import javax.swing.Timer;
import javax.swing.UIManager;
import javax.swing.border.Border;
import javax.swing.filechooser.FileNameExtensionFilter;
import ibxm.*;

public class musicPlayer
{
	private Module module;
	private IBXM ibxm;
	private volatile boolean playing;
	private int interpolation, sliderPos, samplePos, duration;
	private Thread playThread;

	public musicPlayer(URL fileURL)
	{
		this.module = new Module(fileURL);
		ibxm = new IBXM(this.module, 22050);
	}

	public musicPlayer(Module module)
	{
		this.module = module;
		ibxm = new IBXM(this.module, 22050);
	}

	public synchronized void play()
	{
		if( ibxm != null )
		{
			playing = true;
			playThread = new Thread( new Runnable()
			{
				public void run()
				{
					int[] mixBuf = new int[ ibxm.getMixBufferLength() ];
					byte[] outBuf = new byte[ mixBuf.length * 2 ];
					AudioFormat audioFormat = null;
					SourceDataLine audioLine = null;
					try
					{
						audioFormat = new AudioFormat( 22050, 16, 2, true, true );
						audioLine = AudioSystem.getSourceDataLine( audioFormat );
						audioLine.open();
						audioLine.start();
						while( playing )
						{
							int count = getAudio( mixBuf );
							int outIdx = 0;
							for( int mixIdx = 0, mixEnd = count * 2; mixIdx < mixEnd; mixIdx++ )
							{
								int ampl = mixBuf[ mixIdx ];
								if( ampl > 32767 ) ampl = 32767;
								if( ampl < -32768 ) ampl = -32768;
								outBuf[ outIdx++ ] = ( byte ) ( ampl >> 8 );
								outBuf[ outIdx++ ] = ( byte ) ampl;
							}
							audioLine.write( outBuf, 0, outIdx );
						}
						audioLine.drain();
					}
					catch( Exception e )
					{
						System.out.println("Error playing MOD..");
					}
					finally
					{
						if( audioLine != null && audioLine.isOpen() )
							audioLine.close();
					}	
				}
			} );
			playThread.start();
		}
	}

	public synchronized void stop() {
		playing = false;
		try
		{
			if( playThread != null )
			{
				playThread.join();
			}
		}
		catch( InterruptedException e )
		{
			System.out.println("Error stopping MOD..");
		}
	}

	private synchronized int getAudio( int[] mixBuf )
	{
		int count = ibxm.getAudio( mixBuf );
		samplePos += count;
		return count;
	}
}
