class projectile
{
	final static int MODE_INACTIVE = -1;
	final static int MODE_ACTIVE = 0;
	final static float DEFAULT_RADIUS = 4.0f;
	final static int TYPE_NONE = -1;

	vertex pos,vel;
	int mode;
	int type;
	float radius;

	public boolean isInactive(){ return mode == MODE_INACTIVE; }
	public boolean isActive(){ return mode == MODE_ACTIVE; }

	//die!
	public void kill()
	{
		mode = MODE_INACTIVE;
		vel.zero();
	}

	public void move()
	{
		pos.add(vel);
	}

	void setDefaults()
	{
		pos = new vertex();
		vel = new vertex();
		mode = MODE_ACTIVE;
		radius = DEFAULT_RADIUS;
		type = TYPE_NONE;
	}

	//constructors
	public projectile()
	{
		setDefaults();
	}
	public projectile(vertex coords, vertex vCoords)
	{
		setDefaults();
		pos = new vertex(coords);
		vel = new vertex(vCoords);
	}
	public projectile(vertex coords, float ang, float spd)
	{
		setDefaults();
		pos = new vertex(coords);
		vel = new vertex(spd*(float)Math.cos(ang), spd*(float)Math.sin(ang));
	}
}
