//todo: don't add sprites if they lie outside the visible window..
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.awt.image.ColorModel;
import java.awt.Toolkit.*;
import java.awt.geom.*;
import javax.swing.ImageIcon;

//zbuffer class
class zBuffer
{
        final static int MAX_SCREEN_SPRITES = 512;
        public int num_sprites;
        public sprite zBufferSprite[] = new sprite[MAX_SCREEN_SPRITES];

        //constructor methods
        public zBuffer(){ }

        //add an image to the zbuffer..
        public void drawImage(BufferedImage img, BufferedImageOp imgOp, float x, float y, float z){
                zBufferSprite[num_sprites++] = new sprite(img, imgOp, x, y, z);
                }
        //add an image to the zbuffer (sans transform)..
        public void drawImage(BufferedImage img, float x, float y, float z){
                zBufferSprite[num_sprites++] = new sprite(img, x, y, z);
                }
        //add a shape to the zbuffer (sans transform)..
        public void drawImage(int t, Color col, int x, int y, int z, int xo, int yo, int zo){
                zBufferSprite[num_sprites++] = new sprite(t, col, x, y, z, xo, yo, zo);
                }

        //sort the contents of the z-buffer by y-value (use heap sort..)
        public void sort(){
                if(num_sprites == 1 || num_sprites == 0){
                        return;
                        }
                else if(num_sprites < 3){
                        if(zBufferSprite[0].y < zBufferSprite[1].y){
                                sprite tempSprite = zBufferSprite[0];
                                zBufferSprite[0] = zBufferSprite[1];
                                zBufferSprite[1] = tempSprite;
                                }
                        }
                else{           
                        for(int i = 1; i < num_sprites; i++){
                                sprite tempSprite = zBufferSprite[i];
                                int j = i;
                                while(j > 0 && zBufferSprite[j-1].y > tempSprite.y){
                                        zBufferSprite[j] = zBufferSprite[j-1];
                                        j--;
                                        }
                                zBufferSprite[j] = tempSprite;
                                }
                        }
                }

        //display the contents of the zbuffer
        public void display(Graphics2D g2){
                for(int i = 0; i < num_sprites; i++){
                        //g2.drawImage(zBufferSprite[i].img, zBufferSprite[i].imgOp, (int)zBufferSprite[i].x-zBufferSprite[i].w2, (int)zBufferSprite[i].y-zBufferSprite[i].h2);
                        switch(zBufferSprite[i].shapeType){
                                case sprite.SHAPE_LINE:
                                        g2.setColor(zBufferSprite[i].color);
                                        g2.setStroke(new BasicStroke(sprite.LINE_WIDTH));
                                        g2.draw(new Line2D.Float(zBufferSprite[i].x, zBufferSprite[i].y-zBufferSprite[i].z, zBufferSprite[i].w2, zBufferSprite[i].h2-zBufferSprite[i].d2));
                                        g2.setStroke(new BasicStroke(1.0f));
                                        break;
                                case sprite.SHAPE_RECT:
                                        g2.setColor(zBufferSprite[i].color);
                                        //g2.draw(new Rectangle2D.Float(zBufferSprite[i].x-zBufferSprite[i].w2, zBufferSprite[i].y-zBufferSprite[i].h2-zBufferSprite[i].z, zBufferSprite[i].w2*2, zBufferSprite[i].h2*2));
                                        g2.fillRect((int)zBufferSprite[i].x-zBufferSprite[i].w2, (int)(zBufferSprite[i].y-zBufferSprite[i].z)-zBufferSprite[i].h2, zBufferSprite[i].w2*2, zBufferSprite[i].h2*2);
                                        break;
                                case sprite.SHAPE_CIRCLE:
                                        g2.setColor(zBufferSprite[i].color);
                                        //g2.draw(new Rectangle2D.Float(zBufferSprite[i].x-zBufferSprite[i].w2, zBufferSprite[i].y-zBufferSprite[i].h2-zBufferSprite[i].z, zBufferSprite[i].w2*2, zBufferSprite[i].h2*2));
                                        g2.fillOval((int)zBufferSprite[i].x-zBufferSprite[i].w2, (int)(zBufferSprite[i].y-zBufferSprite[i].z)-zBufferSprite[i].h2, zBufferSprite[i].w2*2, zBufferSprite[i].h2*2);
                                        break;
                                default:
                                        g2.drawImage(zBufferSprite[i].img, zBufferSprite[i].imgOp, (int)zBufferSprite[i].x-zBufferSprite[i].w2, (int)(zBufferSprite[i].y-zBufferSprite[i].z)-zBufferSprite[i].h2);
                                        break;
                                }
                        }
                num_sprites = 0;
                }
}
